#include "DlgProcs.h"

void ValidateBitmapSizeData(HWND hDlg, HBITMAP hBitmap);


BOOL CALLBACK BitmapSizeDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static PBITMAPSIZEPARAM pBitmapSizeParam;
	static BITMAP           bitmap;
	char                    szTmp[101];
	long									  Counter;
	int										  iResult;

	switch (message)
		{
		case WM_INITDIALOG:
			pBitmapSizeParam = (PBITMAPSIZEPARAM) lParam;
			if (pBitmapSizeParam->hBitmap)
			{
       	GetObject(pBitmapSizeParam->hBitmap, sizeof(BITMAP), &bitmap);
				itoa(bitmap.bmWidth , szTmp, 10);
				SendDlgItemMessage(hDlg, IDC_WIDTH , CB_ADDSTRING, 0, (LPARAM) szTmp);
				itoa(bitmap.bmHeight, szTmp, 10);
				SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_ADDSTRING, 0, (LPARAM) szTmp);
				for (Counter = 4; Counter<16; Counter++)
				{
					itoa(1<<Counter, szTmp, 10);
					if ((1<<Counter)>=bitmap.bmWidth)
						SendDlgItemMessage(hDlg, IDC_WIDTH , CB_ADDSTRING, 0, (LPARAM) szTmp);
					if ((1<<Counter)>=bitmap.bmHeight)
						SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_ADDSTRING, 0, (LPARAM) szTmp);
				}
			}
			else
				for (Counter = 4; Counter<16; Counter++)
				{
					itoa(1<<Counter, szTmp, 10);
					SendDlgItemMessage(hDlg, IDC_WIDTH , CB_ADDSTRING, 0, (LPARAM) szTmp);
					SendDlgItemMessage(hDlg, IDC_HEIGHT, CB_ADDSTRING, 0, (LPARAM) szTmp);
				}

			SetDlgItemInt(hDlg, IDC_WIDTH   , pBitmapSizeParam->NewWidth , FALSE);
			SetDlgItemInt(hDlg, IDC_HEIGHT  , pBitmapSizeParam->NewHeight, FALSE);
			SetDlgItemInt(hDlg, IDC_OFFSET_X, pBitmapSizeParam->OffX     , FALSE);
			SetDlgItemInt(hDlg, IDC_OFFSET_Y, pBitmapSizeParam->OffY     , FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_OFFSET_X), !pBitmapSizeParam->OffXCenter);
			CheckDlgButton(hDlg, IDC_OFFSET_X_CENTER, pBitmapSizeParam->OffXCenter ? BST_CHECKED : BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg, IDC_OFFSET_Y), !pBitmapSizeParam->OffYCenter);
			CheckDlgButton(hDlg, IDC_OFFSET_Y_CENTER, pBitmapSizeParam->OffYCenter ? BST_CHECKED : BST_UNCHECKED);
			if (pBitmapSizeParam->Border<-4  ||  pBitmapSizeParam->Border>256)  pBitmapSizeParam->Border=0;
			SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_ADDSTRING, 0, (LPARAM) strcpy(szTmp, TEXT("Spiegeln inklusive Randpixel")));
			SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_ADDSTRING, 0, (LPARAM) strcpy(szTmp, TEXT("Spiegeln ohne Randpixel")));
			SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_ADDSTRING, 0, (LPARAM) strcpy(szTmp, TEXT("Periodisch wiederholen")));
			SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_ADDSTRING, 0, (LPARAM) strcpy(szTmp, TEXT("Lokale Mittelwerte")));
			if (pBitmapSizeParam->Border<0)
			{
				SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_SETCURSEL, -1-pBitmapSizeParam->Border, 0);
				SetDlgItemInt(hDlg, IDC_GRAYVALUE, 0, FALSE);
				CheckRadioButton(hDlg, IDC_RADIO_GRAYVALUE, IDC_RADIO_ALGORITHM, IDC_RADIO_ALGORITHM);
				EnableWindow(GetDlgItem(hDlg, IDC_ALGORITHM), TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE_AVG), TRUE);
			}
			else
			{
				SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_SETCURSEL, 0, 0);
				CheckRadioButton(hDlg, IDC_RADIO_GRAYVALUE, IDC_RADIO_ALGORITHM, IDC_RADIO_GRAYVALUE);
				EnableWindow(GetDlgItem(hDlg, IDC_ALGORITHM), FALSE);
				if (pBitmapSizeParam->Border==256)
				{
					SetDlgItemInt(hDlg, IDC_GRAYVALUE, 0, FALSE);
					EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE), FALSE);
					CheckDlgButton(hDlg, IDC_GRAYVALUE_AVG, TRUE);
				}
				else
				{
					SetDlgItemInt(hDlg, IDC_GRAYVALUE, pBitmapSizeParam->Border, FALSE);
					EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE), TRUE);
					CheckDlgButton(hDlg, IDC_GRAYVALUE_AVG, FALSE);
				}
			}
			ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			case IDC_GRAYVALUE_AVG:
				EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE), IsDlgButtonChecked(hDlg, IDC_GRAYVALUE_AVG)!=BST_CHECKED);
				ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDC_RADIO_GRAYVALUE:
			case IDC_RADIO_ALGORITHM:
				EnableWindow(GetDlgItem(hDlg, IDC_ALGORITHM),     IsDlgButtonChecked(hDlg, IDC_RADIO_ALGORITHM)==BST_CHECKED);
				EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE_AVG), IsDlgButtonChecked(hDlg, IDC_RADIO_GRAYVALUE)==BST_CHECKED);
				EnableWindow(GetDlgItem(hDlg, IDC_GRAYVALUE),
					                IsDlgButtonChecked(hDlg, IDC_RADIO_GRAYVALUE)==BST_CHECKED
										   && IsDlgButtonChecked(hDlg, IDC_GRAYVALUE_AVG)  !=BST_CHECKED);
				ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDC_OFFSET_X_CENTER:
				EnableWindow(GetDlgItem(hDlg, IDC_OFFSET_X), IsDlgButtonChecked(hDlg, IDC_OFFSET_X_CENTER)!=BST_CHECKED);
				ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDC_OFFSET_Y_CENTER:
				EnableWindow(GetDlgItem(hDlg, IDC_OFFSET_Y), IsDlgButtonChecked(hDlg, IDC_OFFSET_Y_CENTER)!=BST_CHECKED);
				ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDC_WIDTH:
			case IDC_HEIGHT:
				if (HIWORD(wParam)==CBN_SELCHANGE)
				{
					SendDlgItemMessage(hDlg, LOWORD(wParam), CB_GETLBTEXT,
					                   SendDlgItemMessage(hDlg, LOWORD(wParam), CB_GETCURSEL, 0, 0), (LPARAM) szTmp);
					SetDlgItemText(hDlg, LOWORD(wParam), szTmp);
				}
				if (HIWORD(wParam)==CBN_EDITUPDATE  ||  HIWORD(wParam)==CBN_SELCHANGE)
					ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDC_OFFSET_X:
			case IDC_OFFSET_Y:
			case IDC_GRAYVALUE:
				if (HIWORD(wParam) == EN_CHANGE)  ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDC_ALGORITHM:
				if (HIWORD(wParam)==CBN_SELCHANGE)  ValidateBitmapSizeData(hDlg, pBitmapSizeParam->hBitmap);
				return TRUE;

			case IDOK:
				if (!pBitmapSizeParam->hBitmap)
				{
					BOOL bCorrected = FALSE;
					iResult = GetDlgItemText(hDlg, IDC_WIDTH, szTmp, 100);
					Counter = atoi(szTmp);
				  iResult = 1;
					while ((Counter>>iResult) > 0)  iResult++;
					if ((1<<(iResult-1)) != Counter)
					{
						SetDlgItemInt(hDlg, IDC_WIDTH, 1<<iResult, FALSE);
						bCorrected = TRUE;
					}
					iResult = GetDlgItemText(hDlg, IDC_HEIGHT, szTmp, 100);
					Counter = atoi(szTmp);
				  iResult = 1;
					while ((Counter>>iResult) > 0)  iResult++;
					if ((1<<(iResult-1)) != Counter)
					{
						SetDlgItemInt(hDlg, IDC_HEIGHT, 1<<iResult, FALSE);
						bCorrected = TRUE;
					}
					if (bCorrected)
					{
						MessageBox(hDlg, TEXT("Fr die schnelle Fouriertransformation (FFT) mssen Breite ")
							               TEXT("und Hhe der Bitmap jeweils 2er-Potenzen sein. Ihre Eingabe ")
														 TEXT("fr die Hhe bzw. Breite wurde daher auf die nchst grere ")
														 TEXT("2er-Potenz vergrert. berprfen Sie bitte die neuen Angaben!")
							             , TEXT("Bitmapge ndern - Fehlerhafte Eingabe")
							             , MB_ICONINFORMATION | MB_OK);
						return TRUE;
					}
				}
				iResult = GetDlgItemText(hDlg, IDC_WIDTH   , szTmp, 100);
				pBitmapSizeParam->NewWidth = atoi(szTmp);
				iResult = GetDlgItemText(hDlg, IDC_HEIGHT  , szTmp, 100);
				pBitmapSizeParam->NewHeight = atoi(szTmp);
				iResult = GetDlgItemText(hDlg, IDC_OFFSET_Y, szTmp, 100);
				pBitmapSizeParam->OffY = atoi(szTmp);
				iResult = GetDlgItemText(hDlg, IDC_OFFSET_X, szTmp, 100);
				pBitmapSizeParam->OffX = atoi(szTmp);
				pBitmapSizeParam->OffXCenter = IsDlgButtonChecked(hDlg, IDC_OFFSET_X_CENTER)==BST_CHECKED;
				pBitmapSizeParam->OffYCenter = IsDlgButtonChecked(hDlg, IDC_OFFSET_Y_CENTER)==BST_CHECKED;
				if (IsDlgButtonChecked(hDlg, IDC_RADIO_ALGORITHM)==BST_CHECKED)
					pBitmapSizeParam->Border = -1-SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_GETCURSEL, 0, 0);
				else
				{
					if (IsDlgButtonChecked(hDlg, IDC_GRAYVALUE_AVG)!=BST_CHECKED)
						pBitmapSizeParam->Border = GetDlgItemInt(hDlg, IDC_GRAYVALUE, NULL, FALSE);
					else
						pBitmapSizeParam->Border = 256;
				}
				if (pBitmapSizeParam->Border<-4  ||  pBitmapSizeParam->Border>256)  pBitmapSizeParam->Border=0;
				EndDialog(hDlg, TRUE);
				return TRUE;

			case IDCANCEL:
				EndDialog(hDlg, FALSE);
				return TRUE;
			}
			break;
	}
	return FALSE;
}




void ValidateBitmapSizeData(HWND hDlg, HBITMAP hBitmap)
{
	char             szTmp[101];
	long					   Counter;
	int							 iResult;
	long             Width, Height, OffX, OffY;
	BOOL             DataOk = TRUE;

	iResult = GetDlgItemText(hDlg, IDC_WIDTH, szTmp, 100);
	if (iResult>=99)  DataOk=FALSE;
	if (DataOk)
	{
		Counter=0;
		while (szTmp[Counter])
		{
			if (szTmp[Counter]<'0'  ||  szTmp[Counter]>'9')  DataOk=FALSE;
			Counter++;
		}
	}
	Width = atoi(szTmp);

	iResult = GetDlgItemText(hDlg, IDC_HEIGHT, szTmp, 100);
	if (iResult>=99)  DataOk=FALSE;
	if (DataOk)
	{
		Counter=0;
		while (szTmp[Counter])
		{
			if (szTmp[Counter]<'0'  ||  szTmp[Counter]>'9')  DataOk=FALSE;
			Counter++;
		}
	}
	Height = atoi(szTmp);

	if (IsDlgButtonChecked(hDlg, IDC_OFFSET_X_CENTER)!=BST_CHECKED)
		OffX = GetDlgItemInt(hDlg, IDC_OFFSET_X, NULL, FALSE);
	if (IsDlgButtonChecked(hDlg, IDC_OFFSET_Y_CENTER)!=BST_CHECKED)
		OffY = GetDlgItemInt(hDlg, IDC_OFFSET_Y, NULL, FALSE);

	if (hBitmap)
	{
		BITMAP bitmap;
		GetObject(hBitmap, sizeof(BITMAP), &bitmap);
		if (Width <bitmap.bmWidth ) DataOk=FALSE;
		if (Height<bitmap.bmHeight) DataOk=FALSE;
		if (IsDlgButtonChecked(hDlg, IDC_OFFSET_X_CENTER)!=BST_CHECKED  &&  OffX>Width -bitmap.bmWidth )  DataOk=FALSE;
		if (IsDlgButtonChecked(hDlg, IDC_OFFSET_Y_CENTER)!=BST_CHECKED  &&  OffY>Height-bitmap.bmHeight)  DataOk=FALSE;
	}
	else
	{
		if (IsDlgButtonChecked(hDlg, IDC_OFFSET_X_CENTER)!=BST_CHECKED  &&  OffX>Width )  DataOk=FALSE;
		if (IsDlgButtonChecked(hDlg, IDC_OFFSET_Y_CENTER)!=BST_CHECKED  &&  OffY>Height)  DataOk=FALSE;
	}
					
	if (Width<4  ||  Height<4)  DataOk=FALSE;

	if (IsDlgButtonChecked(hDlg, IDC_RADIO_ALGORITHM)==BST_CHECKED)
	{
		if (SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_GETCURSEL, 0, 0)<0
			    ||  SendDlgItemMessage(hDlg, IDC_ALGORITHM, CB_GETCURSEL, 0, 0)>3)  DataOk=FALSE;
	}
	else
	{
		if (IsDlgButtonChecked(hDlg, IDC_GRAYVALUE_AVG)!=BST_CHECKED)
			if (GetDlgItemInt(hDlg, IDC_GRAYVALUE, NULL, FALSE)<0
				     || GetDlgItemInt(hDlg, IDC_GRAYVALUE, NULL, FALSE)>255)  DataOk=FALSE;
	}
	EnableWindow(GetDlgItem(hDlg, IDOK), DataOk);
}