#include "DlgProcs.h"

void PreviewBitOp(PBITOPPARAM pBitOpParam, int iResult, HWND hwnd, RGBQUAD *OldRGBPal);


/*******************************************************
 *                                                     *
 *              DIALOGPROZEDUR:    BitsDlg             *
 *                                                     *
 *******************************************************/

BOOL CALLBACK BitsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static PBITOPPARAM pBitOpParam;
	static int				 iResult;
	static RGBQUAD     OldRGBPal[256];
	TCHAR              szCaption[80];
	int                Pos1, Pos2;

	switch (message)
		{
		case WM_INITDIALOG:
			pBitOpParam = (PBITOPPARAM) lParam;
			GetRGBPalette(pBitOpParam->hBitmap, OldRGBPal);
			strcpy(szCaption, TEXT("Bitauswahl"));
			if (pBitOpParam->szMenuString)
			{
				strcat(szCaption, TEXT(" fr "));
				Pos1 = 0;
				Pos2 = strlen(szCaption);
				while (pBitOpParam->szMenuString[Pos1])
				{
					if (pBitOpParam->szMenuString[Pos1] != '&'  &&  pBitOpParam->szMenuString[Pos1] != '.')
					{
						szCaption[Pos2] = pBitOpParam->szMenuString[Pos1];
						Pos2++;
					}
					Pos1++;
				}
				szCaption[Pos2] = 0;
			}
			SetWindowText(hDlg, szCaption);
			SetDlgItemInt(hDlg, IDC_DECNUM, iResult, FALSE);
		  CheckDlgButton(hDlg, IDC_BIT0, iResult & 1);
			CheckDlgButton(hDlg, IDC_BIT1, iResult & 2);
			CheckDlgButton(hDlg, IDC_BIT2, iResult & 4);
			CheckDlgButton(hDlg, IDC_BIT3, iResult & 8);
			CheckDlgButton(hDlg, IDC_BIT4, iResult & 16);
			CheckDlgButton(hDlg, IDC_BIT5, iResult & 32);
			CheckDlgButton(hDlg, IDC_BIT6, iResult & 64);
			CheckDlgButton(hDlg, IDC_BIT7, iResult & 128);
			EnableWindow( GetDlgItem(hDlg, IDOK), iResult>=0 && iResult<=255);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			case IDC_DECNUM:
				   if (HIWORD (wParam) == EN_CHANGE)
					 {
						 iResult = GetDlgItemInt(hDlg, IDC_DECNUM, NULL, FALSE);
						 if (iResult<0 || iResult>255)
						 {
						   EnableWindow( GetDlgItem(hDlg, IDOK), FALSE);
						 }
						 else
						 {
						   EnableWindow( GetDlgItem(hDlg, IDOK), TRUE);
							 CheckDlgButton(hDlg, IDC_BIT0, iResult & 1);
							 CheckDlgButton(hDlg, IDC_BIT1, iResult & 2);
							 CheckDlgButton(hDlg, IDC_BIT2, iResult & 4);
							 CheckDlgButton(hDlg, IDC_BIT3, iResult & 8);
							 CheckDlgButton(hDlg, IDC_BIT4, iResult & 16);
							 CheckDlgButton(hDlg, IDC_BIT5, iResult & 32);
							 CheckDlgButton(hDlg, IDC_BIT6, iResult & 64);
							 CheckDlgButton(hDlg, IDC_BIT7, iResult & 128);
							 PreviewBitOp(pBitOpParam, iResult, GetParent(hDlg), OldRGBPal);
						 }
					 }
					 return TRUE;

			case IDC_BIT0:
			case IDC_BIT1:
			case IDC_BIT2:
			case IDC_BIT3:
			case IDC_BIT4:
			case IDC_BIT5:
			case IDC_BIT6:
			case IDC_BIT7:
				iResult =   IsDlgButtonChecked(hDlg, IDC_BIT0)
					        + IsDlgButtonChecked(hDlg, IDC_BIT1) * 2
									+ IsDlgButtonChecked(hDlg, IDC_BIT2) * 4
									+ IsDlgButtonChecked(hDlg, IDC_BIT3) * 8
									+ IsDlgButtonChecked(hDlg, IDC_BIT4) * 16
									+ IsDlgButtonChecked(hDlg, IDC_BIT5) * 32
									+ IsDlgButtonChecked(hDlg, IDC_BIT6) * 64
									+ IsDlgButtonChecked(hDlg, IDC_BIT7) * 128;
				SetDlgItemInt(hDlg, IDC_DECNUM, iResult, FALSE);   
				return 0;
			
			case IDOK:
				iResult =   IsDlgButtonChecked(hDlg, IDC_BIT0)
					        + IsDlgButtonChecked(hDlg, IDC_BIT1) * 2
									+ IsDlgButtonChecked(hDlg, IDC_BIT2) * 4
									+ IsDlgButtonChecked(hDlg, IDC_BIT3) * 8
									+ IsDlgButtonChecked(hDlg, IDC_BIT4) * 16
									+ IsDlgButtonChecked(hDlg, IDC_BIT5) * 32
									+ IsDlgButtonChecked(hDlg, IDC_BIT6) * 64
									+ IsDlgButtonChecked(hDlg, IDC_BIT7) * 128;
				SetRGBPalette(pBitOpParam->hBitmap, OldRGBPal);
				SaveForUndo(pBitOpParam->hBitmap, pBitOpParam->szMenuString);
				CalcBitOp(pBitOpParam->hBitmap, pBitOpParam->Operation, iResult);
				InvalidateRect(GetParent(hDlg), NULL, FALSE);
				EndDialog(hDlg, TRUE);
				return TRUE;

			case IDCANCEL:
				SetRGBPalette(pBitOpParam->hBitmap, OldRGBPal);
				InvalidateRect(GetParent(hDlg), NULL, FALSE);
				EndDialog(hDlg, FALSE);
				return TRUE;
			}
			break;
	}
	return FALSE;
}



void PreviewBitOp(PBITOPPARAM pBitOpParam, int Operand, HWND hwnd, RGBQUAD *OldRGBPal)
{
	RGBQUAD NewRGBPal[256];
  int counter;

	switch (pBitOpParam->Operation)
	{
	case IDM_BITOP_AND:
		for (counter = 0; counter < 256; counter++)
	    NewRGBPal[counter] = OldRGBPal[counter & Operand];
		SetRGBPalette(pBitOpParam->hBitmap, NewRGBPal);
		break;

	case IDM_BITOP_OR:
		for (counter = 0; counter < 256; counter++)
	    NewRGBPal[counter] = OldRGBPal[counter | Operand];
		SetRGBPalette(pBitOpParam->hBitmap, NewRGBPal);
		break;

	case IDM_BITOP_XOR:
		for (counter = 0; counter < 256; counter++)
	    NewRGBPal[counter] = OldRGBPal[counter ^ Operand];
		SetRGBPalette(pBitOpParam->hBitmap, NewRGBPal);
		break;

	default:
		SetRGBPalette(pBitOpParam->hBitmap, OldRGBPal);
		break;
	}
	InvalidateRect(hwnd, NULL, FALSE);
}
