#define  WINVER 0x0500
#define  _WIN32_WINNT 0x0500
#include <windows.h>
#include <commdlg.h>
#include <math.h>
#include "resource.h"
#include "DIBs.h"
#include "Numerical.h"
#include "Undo.h"


typedef struct tagINPUTNUMBERPARAM
{
  TCHAR   szCaption[80], szLabelNr1[40], szLabelNr2[40]; 
	float   EditNr1;
	float   EditNr2;
	BOOL    Nr1NonNegative, Nr2NonNegative, Nr1Positiv, Nr2Positiv;
}
INPUTNUMBERPARAM, *PINPUTNUMBERPARAM;

typedef struct tagSELMANUALPARAM
{
  HBITMAP hBitmap;
	BOOL    bFFT;
	RECT    LastRect;
	RECT   *pRect;
}
SELMANUALPARAM, *PSELMANUALPARAM;

typedef struct tagPENCOLORPARAM
{
  BYTE LButtonGrayVal;
	BYTE RButtonGrayVal;
}
PENCOLORPARAM, *PPENCOLORPARAM;

typedef struct tagBITMAPSIZEPARAM
{
  HBITMAP hBitmap;
  long    NewWidth, NewHeight, OffX, OffY;
	BOOL    OffXCenter, OffYCenter; 
	int     Border;
}
BITMAPSIZEPARAM, *PBITMAPSIZEPARAM;

typedef struct tagBITOPPARAM
{
  HBITMAP hBitmap;
  int     Operation;
	TCHAR   szMenuString[80];
}
BITOPPARAM, *PBITOPPARAM;

typedef struct tagPALETTEPARAM
{
	HINSTANCE hInstance;
  HBITMAP   hBitmap;
  HWND      hInfoBox;
}
PALETTEPARAM, *PPALETTEPARAM;

typedef struct tagLOCOPSIZEPARAM
{
  HBITMAP hBitmap;
  int     Operation, Width, Height, Param, Compare;
}
LOCOPSIZEPARAM, *PLOCOPSIZEPARAM;

typedef struct tagSPECTRUMPARAM
{
	HINSTANCE hInstance;
  HBITMAP   hBitmap, hSpectBMP;
  long      Width, Height, OffX, OffY, BorderParam;
	float     *OldSpectRe, *OldSpectIm, *FilterRe, *FilterIm, *SpectRe, *SpectIm, *Floats;
	HWND      hInfoBox;
}
SPECTRUMPARAM, *PSPECTRUMPARAM;

typedef struct tagPARTICLEPARAM
{
//	HINSTANCE hInstance;
  HBITMAP   hBitmap;
	RGBQUAD   *OldRGBPal;
	long      Algorithm;
  long      MinGrayVal;
	long      MinArea, MaxArea;
}
PARTICLEPARAM, *PPARTICLEPARAM;



BOOL CALLBACK AboutBoxProc         (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK InfoBoxProc          (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK InputNumberDlgProc   (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK SelectManualDlgProc  (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK PenColorDlgProc      (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK BitmapSizeDlgProc    (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK BitsDlgProc          (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK PaletteDlgProc       (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK LocOpSizeDlgProc     (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK FilterSpectDlgProc   (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK InverseFFTDlgProc    (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ParticleParamsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);