#include "DlgProcs.h"
#include <float.h>

extern BOOL CheckBorder(int &xShow, int &yShow, int cxClient, int cyClient, long ShowWidth, long ShowHeight);
extern BOOL PaintTheBitmap(HDC hdc, HBITMAP hBitmap, int xShow, int yShow, long ShowWidth, long ShowHeight, int cxClient, int cyClient);
extern void DrawSelectionRect(HDC hdc, BITMAP bitmap, int xShow, int yShow, long ShowWidth, long ShowHeight, RECT SelRect, BOOL bSelecting);
void        DrawLineInFFT(SPECTRUMPARAM SP, RECT SelRect, RECT DrawRect, int PenWidth, float DrawRe, float DrawIm, int GrayVal, BYTE *pMemBits);

// Globale Variablen
extern UINT MSWHEEL_ROLLMSG;

void MoveSpectrum(float *fRe, float *fIm, float *pFloats, long Width, long Height, int Sign);
void UpdateSpectBMP(HWND hDlg, HBITMAP hBitmap, SPECTRUMPARAM sp, float Power, BOOL UpdateFilteredSpect);
int  LoadFFT(TCHAR *szFileName, float *fRe, float *fIm, long Width, long Height);
BOOL SaveFFT(TCHAR *szFileName, float *fRe, float *fIm, long Width, long Height);

BOOL CALLBACK FilterSpectDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
     static BYTE				 *pBits, *pMemBits;
		 static RECT         SelRect, XORSelRect, OldSelRect;
		 static int          cxClient, cyClient, xShow, yShow, xMousePos, yMousePos;
     static float				 ShowSizeFactor, Power = 0.1f;
     static long				 ShowWidth, ShowHeight;
		 static boolean			 bChanged = FALSE, bScroll = FALSE, bZoom = FALSE,
			                   bDrawLB = FALSE, bDrawRB = FALSE, bDrawingLine = FALSE,
												 bSelecting = FALSE, bDelOldSelRect = FALSE, bSelMoving = FALSE;
		 static OPENFILENAME ofn;
     static TCHAR        szFileName[MAX_PATH], szTitleName[MAX_PATH], szBMPFileName[MAX_PATH];
     static TCHAR        szFilter[] = TEXT ("Frequenz-Filter-Dateien (*.FFT)\0*.fft\0")
                                      TEXT ("Alle Dateien (*.*)\0*.*\0\0");
     static TCHAR        szBMPFilter[] = TEXT ("Windows-Bitmap (*.BMP)\0*.bmp\0")
                                         TEXT ("Alle Dateien (*.*)\0*.*\0\0");
		 static HINSTANCE		 hInstance;
		 static HWND         hInfoBox;
		 HMENU							 hMenu;
		 static HBITMAP      hBitmap;
		 HBITMAP             hFilterBitmap;
     static BITMAP       bitmap;
		 BITMAP              filterbitmap;
		 HDC                 hdc;
		 RECT                rect;
     PAINTSTRUCT         ps;

		 static PSPECTRUMPARAM pSP;
		 INPUTNUMBERPARAM      InpNr;
		 float                 *fRe, *fIm, f;
		 BOOL   						   bTemp;
		 int								   iResult;
		 static int            PenWidth;
		 double							   Factor;
		 long								   x, y, i, j, Offset;
		 #define MAXSZTEMP 80
		 TCHAR                 szTemp[MAXSZTEMP];

     switch (message)
     {
     case WM_INITDIALOG:   
			    pSP = (PSPECTRUMPARAM) lParam;
					hInstance = pSP->hInstance;
					hInfoBox = pSP->hInfoBox;
					hBitmap = pSP->hSpectBMP;
					GetObject(hBitmap, sizeof(BITMAP), &bitmap);
					pBits = (BYTE*) bitmap.bmBits;
					GetClientRect(hDlg, &rect);
					cxClient = rect.right;
					cyClient = rect.bottom;
					ShowWidth  = bitmap.bmWidth;
					ShowHeight = bitmap.bmHeight;
					xShow = (cxClient-ShowWidth)/2;
					yShow = (cyClient-ShowHeight)/2;
					MoveSpectrum(pSP->OldSpectRe, pSP->OldSpectIm, pSP->Floats, pSP->Width, pSP->Height, 1);
					for (Offset=0; Offset<pSP->Height*pSP->Width; Offset++)
					{
						pSP->FilterRe[Offset] = 1;
						pSP->FilterIm[Offset] = 0;
						pSP->SpectRe[Offset]  = pSP->OldSpectRe[Offset];
						pSP->SpectIm[Offset]  = pSP->OldSpectIm[Offset];
					}
					SelRect.left   = 0;
					SelRect.bottom = 0;
					SelRect.top    = bitmap.bmHeight-1;
					SelRect.right  = bitmap.bmWidth-1;
					ofn.lStructSize       = sizeof (OPENFILENAME);
          ofn.hwndOwner         = hDlg;
          ofn.hInstance         = NULL;
          ofn.lpstrFilter       = szFilter;
          ofn.lpstrCustomFilter = NULL;
          ofn.nMaxCustFilter    = 0;
          ofn.nFilterIndex      = 0;
          ofn.lpstrFile         = szFileName;
          ofn.nMaxFile          = MAX_PATH;
          ofn.lpstrFileTitle    = szTitleName;
          ofn.nMaxFileTitle     = MAX_PATH;
          ofn.lpstrInitialDir   = NULL;
          ofn.lpstrTitle        = NULL;
          ofn.Flags             = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
          ofn.nFileOffset       = 0;
          ofn.nFileExtension    = 0;
          ofn.lpstrDefExt       = TEXT ("fft");
          ofn.lCustData         = 0;
          ofn.lpfnHook          = NULL;
          ofn.lpTemplateName    = NULL;
					PenWidth = 1;
					UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
          return TRUE;

     case WM_SIZE:
          bTemp = FALSE;
					if (LOWORD(lParam)>cxClient)  bTemp = TRUE;
					if (HIWORD(lParam)>cyClient)  bTemp = TRUE;
					cxClient = LOWORD (lParam);
          cyClient = HIWORD (lParam);
					if (hBitmap)
						if (CheckBorder(xShow, yShow, cxClient, cyClient, ShowWidth, ShowHeight))
							bTemp = TRUE;
					if (bTemp)  InvalidateRect(hDlg, NULL, FALSE);
          return TRUE;

     case WM_INITMENUPOPUP:
			    if (HIWORD(lParam) == 0)
					{
						bTemp = FALSE;
						if (hBitmap  &&  IsClipboardFormatAvailable(CF_DIB))
						{
							GetDIBSizeFromClipboard(hDlg, x, y);
							if (x==pSP->Width  &&  y==pSP->Height)  bTemp = TRUE;
						}
						EnableMenuItem ((HMENU) wParam, IDM_FILTER_IMPORTFROMBMPCLIP,
							               bTemp ? MF_ENABLED : MF_GRAYED);
						EnableMenuItem ((HMENU) wParam, IDM_FILTER_IMPORTREALFROMBMPCLIP,
							               bTemp ? MF_ENABLED : MF_GRAYED);
						EnableMenuItem ((HMENU) wParam, IDM_FILTER_IMPORTIMAGFROMBMPCLIP,
							               bTemp ? MF_ENABLED : MF_GRAYED);
						CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_1x1, (PenWidth == 1) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_2x2, (PenWidth == 2) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_3x3, (PenWidth == 3) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_4x4, (PenWidth == 4) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_5x5, (PenWidth == 5) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_6x6, (PenWidth == 6) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_7x7, (PenWidth == 7) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_8x8, (PenWidth == 8) ? MF_CHECKED : MF_UNCHECKED);
				    CheckMenuItem((HMENU) wParam, IDM_TOOLS_PEN_9x9, (PenWidth == 9) ? MF_CHECKED : MF_UNCHECKED);
					}
			    return TRUE;;

		 case WM_COMMAND:
          switch (LOWORD (wParam))
          {
          case IDM_OPEN_UNFILTERED:
					case IDM_OPEN_FILTER:
						   // Standarddialog zum ffnen von Dateien
							 ofn.lpstrFilter = szFilter;
							 ofn.lpstrFile = szFileName;
               ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
               if (!GetOpenFileName(&ofn))  return 0;
							 iResult = LoadFFT(szFileName, pSP->SpectRe, pSP->SpectIm, pSP->Width, pSP->Height);
							 switch (iResult)
							 {
								 case 1:
									 MessageBox(hDlg, TEXT("Fehler beim ffnen bzw. Laden der Datei!"), TEXT("Particle Tracer - FFT laden"), MB_OK | MB_ICONEXCLAMATION);
								   return TRUE;

								 case 2:
									 MessageBox(hDlg, TEXT("Ungltige Kennung in der Datei! Falsches Dateiformat?"), TEXT("Particle Tracer - FFT laden"), MB_OK | MB_ICONEXCLAMATION);
								   return TRUE;

								 case 3:
									 MessageBox(hDlg, TEXT("Gre des Filters stimmt nicht mit dem der Datei berein!"), TEXT("Particle Tracer - FFT laden"), MB_OK | MB_ICONEXCLAMATION);
								   return TRUE;

								 case 4:
									 MessageBox(hDlg, TEXT("Fehler beim ffnen bzw. Laden der Datei!"), TEXT("Particle Tracer - FFT laden"), MB_OK | MB_ICONEXCLAMATION);
									 break;

								 case 0:
								   if (LOWORD(wParam) == IDM_OPEN_UNFILTERED)
									 {
										 fRe = pSP->OldSpectRe;  pSP->OldSpectRe = pSP->SpectRe;  pSP->SpectRe = fRe;
										 fIm = pSP->OldSpectIm;  pSP->OldSpectIm = pSP->SpectIm;  pSP->SpectIm = fIm;
									 }
									 else
									 {
										 fRe = pSP->FilterRe;  pSP->FilterRe = pSP->SpectRe;  pSP->SpectRe = fRe;
										 fIm = pSP->FilterIm;  pSP->FilterIm = pSP->SpectIm;  pSP->SpectIm = fIm;
									 }
									 break;
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;
               
					case IDM_SAVE_UNFILTERED:
					case IDM_SAVE_FILTER:
					case IDM_SAVE_FILTERED:
						   if (LOWORD(wParam) == IDM_SAVE_UNFILTERED)
							 {
								 fRe = pSP->OldSpectRe;
							   fIm = pSP->OldSpectIm;
							 }
							 else if (LOWORD(wParam) == IDM_SAVE_FILTERED)
							 {
								 fRe = pSP->SpectRe;
							   fIm = pSP->SpectIm;
							 }
							 else
							 {
								 fRe = pSP->FilterRe;
								 fIm = pSP->FilterIm;
							 }
						   // Standarddialog zum Speichern von Dateien
						   ofn.lpstrFilter = szFilter;
						   ofn.lpstrFile = szFileName;
		           ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT;
						   if (!GetSaveFileName (&ofn))  return 0;
							 if (!SaveFFT(szFileName, fRe, fIm, pSP->Width, pSP->Height))
								 MessageBox(hDlg, TEXT("Beim Speichern ist ein Fehler aufgetreten!"), TEXT("Particle Tracer - FFT speichern"), MB_OK | MB_ICONEXCLAMATION);
							 return TRUE;

					case IDM_SAVE_SPECTBMP:
						   ofn.lpstrFilter = szBMPFilter;
						   ofn.lpstrFile = szBMPFileName;
		           ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT;
						   if (!GetSaveFileName (&ofn))  return 0;
							 WriteDibSectionToDibFile(hBitmap, szBMPFileName);
						   return TRUE;

					case IDM_CLIP_SPECTBMP:
						   CopyDIBtoClipboard(hDlg, hBitmap, SelRect);
						   return TRUE;
					
					case IDM_TOOLS_MOVE:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_TOOLS_MOVE, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_TOOLS_DRAW, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_TOOLS_SELECT, MF_UNCHECKED);
						   return TRUE;

					case IDM_TOOLS_SELECT:
							 hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_TOOLS_MOVE, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_TOOLS_DRAW, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_TOOLS_SELECT, MF_CHECKED);
							 SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("crosscursor")) );
						   return TRUE;
					
					case IDM_TOOLS_DRAW:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_TOOLS_MOVE, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_TOOLS_DRAW, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_TOOLS_SELECT, MF_UNCHECKED);
						   return TRUE;

					case IDM_TOOLS_SELMANUAL:
						{
							 static SELMANUALPARAM SelManualParam;

							 OldSelRect = SelRect;
							 SelManualParam.hBitmap  =  hBitmap;
							 SelManualParam.bFFT     =  TRUE;
							 SelManualParam.pRect    = &SelRect;
							 if (!DialogBoxParam(hInstance, TEXT("SelectManualDlg"), hDlg, SelectManualDlgProc, (LPARAM) &SelManualParam))
							 {
								 SelRect = OldSelRect;
								 InvalidateRect(hDlg, NULL, FALSE);
							 }
							 else
							 {
								 SelManualParam.LastRect = SelRect;
							 }
						   return TRUE;
						}

					case IDM_TOOLS_PEN_1x1:
						   PenWidth = 1;
						   return 0;
					case IDM_TOOLS_PEN_2x2:
						   PenWidth = 2;
						   return 0;
					case IDM_TOOLS_PEN_3x3:
						   PenWidth = 3;
						   return 0;
					case IDM_TOOLS_PEN_4x4:
						   PenWidth = 4;
						   return 0;
					case IDM_TOOLS_PEN_5x5:
						   PenWidth = 5;
						   return 0;
					case IDM_TOOLS_PEN_6x6:
						   PenWidth = 6;
						   return 0;
					case IDM_TOOLS_PEN_7x7:
						   PenWidth = 7;
						   return 0;
					case IDM_TOOLS_PEN_8x8:
						   PenWidth = 8;
						   return 0;
					case IDM_TOOLS_PEN_9x9:
						   PenWidth = 9;
						   return 0;

					case IDM_VIEW_UNFILTERED:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_UNFILTERED, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_FILTER, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_FILTERED, MF_UNCHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_FILTER:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_UNFILTERED, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_FILTER, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_FILTERED, MF_UNCHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_FILTERED:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_UNFILTERED, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_FILTER, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_FILTERED, MF_CHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_ABS:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_ABS, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_PHASE, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_REAL, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_IMAG, MF_UNCHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_PHASE:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_ABS, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_PHASE, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_REAL, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_IMAG, MF_UNCHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_REAL:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_ABS, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_PHASE, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_REAL, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_IMAG, MF_UNCHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_IMAG:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_ABS, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_PHASE, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_REAL, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_IMAG, MF_CHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_VIEW_POWER:
							 strcpy(InpNr.szCaption, TEXT("Bitte geben Sie einen Exponenten (zwischen 0 und 1) an:"));
							 strcpy(InpNr.szLabelNr1, TEXT("Exponenten:"));
							 strcpy(InpNr.szLabelNr2, TEXT(""));
							 InpNr.EditNr1 = Power;
							 InpNr.EditNr2 = 0.0;
							 InpNr.Nr1NonNegative = InpNr.Nr1Positiv = TRUE;
							 InpNr.Nr2NonNegative = InpNr.Nr2Positiv = FALSE;
							 if (!DialogBoxParam(hInstance, TEXT("InputNumberDlg"), hDlg, InputNumberDlgProc, (LPARAM) &InpNr))
								 return TRUE;
							 Power = InpNr.EditNr1;
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_LOGAR, MF_UNCHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_POWER, MF_CHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;
							 
					case IDM_VIEW_LOGAR:
						   hMenu = GetMenu(hDlg);
						   CheckMenuItem(hMenu, IDM_VIEW_LOGAR, MF_CHECKED);
						   CheckMenuItem(hMenu, IDM_VIEW_POWER, MF_UNCHECKED);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, FALSE);
						   return TRUE;

					case IDM_COLORS_SETGRAYPAL:
							 SetStandardPalette(hBitmap);
							 InvalidateRect(hDlg, NULL, FALSE);
						   return TRUE;

					case IDM_COLORS_RAINBOW:
							 {
								 RGBQUAD NewPal[256];
								 for (i=0; i<64; i++)
								 {
									 NewPal[i].rgbBlue  = BYTE(i * 4);
									 NewPal[i].rgbGreen = 0;
									 NewPal[i].rgbRed   = 0;
									 NewPal[i].rgbReserved = 0;
								 }
								 for (i=64; i<128; i++)
								 {
									 NewPal[i].rgbBlue  = BYTE(255-4*(i-64));
									 NewPal[i].rgbGreen = BYTE((i-64)*4);
									 NewPal[i].rgbRed   = 0;
									 NewPal[i].rgbReserved = 0;
								 }
								 for (i=128; i<192; i++)
								 {
									 NewPal[i].rgbBlue  = 0;
									 NewPal[i].rgbGreen = 255;
									 NewPal[i].rgbRed   = BYTE((i-128)*4);
									 NewPal[i].rgbReserved = 0;
								 }
								 for (i=192; i<256; i++)
								 {
									 NewPal[i].rgbBlue  = 0;
									 NewPal[i].rgbGreen = BYTE(255-(i-192)*4);
									 NewPal[i].rgbRed   = 255;
									 NewPal[i].rgbReserved = 0;
								 }
								 SetRGBPalette(hBitmap, NewPal);							 
							 }
							 InvalidateRect(hDlg, NULL, FALSE);
						   return TRUE;

					case IDM_COLORS_LOADRGBPAL:
							 // Welche Datei...?
							 {
								 static OPENFILENAME ofn;
								 static TCHAR        szRGBPalName [MAX_PATH] = TEXT("");
								 static TCHAR        szRGBPalTitle[MAX_PATH] = TEXT("");
								 TCHAR szRGBPalFilter[] = TEXT ("RGB-Palette (*.RGB)\0*.rgb\0")
                                          TEXT ("Alle Dateien (*.*)\0*.*\0\0");
								 ofn.lStructSize       = sizeof (OPENFILENAME);
			           ofn.hwndOwner         = hDlg;
						     ofn.hInstance         = NULL;
			           ofn.lpstrFilter       = szRGBPalFilter;
						     ofn.lpstrCustomFilter = NULL;
			           ofn.nMaxCustFilter    = 0;
						     ofn.nFilterIndex      = 0;
			           ofn.lpstrFile         = szRGBPalName;
						     ofn.nMaxFile          = MAX_PATH;
			           ofn.lpstrFileTitle    = szRGBPalTitle;
						     ofn.nMaxFileTitle     = MAX_PATH;
			           ofn.lpstrInitialDir   = NULL;
						     ofn.lpstrTitle        = NULL;
			           ofn.Flags             = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
						     ofn.nFileOffset       = 0;
			           ofn.nFileExtension    = 0;
						     ofn.lpstrDefExt       = TEXT ("rgb");
			           ofn.lCustData         = 0;
						     ofn.lpfnHook          = NULL;
			           ofn.lpTemplateName    = NULL;
				         if (!GetOpenFileName(&ofn))
					         return TRUE;
								 // Wenn nicht abgebrochen...
								 {
									 RGBQUAD NewRGBPal[256];
	
									 // Versuche einzuladen
									 if (!LoadRGBPalette(szRGBPalName, NewRGBPal))
									 {
										 // Wenn Fehler: Meldung anzeigen und Routine verlassen
										 MessageBox(hDlg, TEXT("RGB-Palette einladen fehlgeschlagen! Falsches Dateiformat?"),
											                TEXT("Fehler beim Einladen der RGB-Palette"), MB_OK | MB_ICONEXCLAMATION);
										 return TRUE;
									 }

									 // Ansonsten:
								   SetRGBPalette(hBitmap, NewRGBPal);
								 }
							 }
							 InvalidateRect(hDlg, NULL, FALSE);
						   return TRUE;

					case IDM_FILTER_IMPORTFROMBMPFILE:
					case IDM_FILTER_IMPORTREALFROMBMPFILE:
					case IDM_FILTER_IMPORTIMAGFROMBMPFILE:
						   ofn.lpstrFilter = szBMPFilter;
						   ofn.lpstrFile = szBMPFileName;
               ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
               if (!GetOpenFileName(&ofn))  return TRUE;
							 hFilterBitmap = CreateDibSectionFromDibFile(szBMPFileName, bTemp);
							 if (!hFilterBitmap)
							 {
								 MessageBox(hDlg, TEXT("Fehler beim ffnen der Bitmap-Datei! Falsches Format?"), TEXT("Particle Tracer - Filter importieren"), MB_OK | MB_ICONEXCLAMATION);
								 return TRUE;
							 }
							 GetObject(hFilterBitmap, sizeof(BITMAP), &filterbitmap);
							 if (filterbitmap.bmWidth!=pSP->Width  ||  filterbitmap.bmHeight!=pSP->Height)
							 {
								 DeleteObject(hFilterBitmap);
								 MessageBox(hDlg, TEXT("Bitmap hat nicht die korrekte Gre!"), TEXT("Particle Tracer - Filter importieren"), MB_OK | MB_ICONEXCLAMATION);
								 return TRUE;
							 }
							 if (LOWORD(wParam)==IDM_FILTER_IMPORTFROMBMPFILE  ||  LOWORD(wParam)==IDM_FILTER_IMPORTREALFROMBMPFILE)
							 {
								 Offset = 0;
								 for (y=0; y<pSP->Height; y++)
								 {
									 for (x=0; x<pSP->Width; x++)
									 {
										 pSP->FilterRe[Offset] = ((BYTE*) filterbitmap.bmBits)[y*filterbitmap.bmWidthBytes+x] / 255.0f;
										 Offset++;
									 }
								 }
							 }
							 if (LOWORD(wParam)==IDM_FILTER_IMPORTIMAGFROMBMPFILE)
							 {
								 Offset = 0;
								 for (y=0; y<pSP->Height; y++)
								 {
									 for (x=0; x<pSP->Width; x++)
									 {
										 pSP->FilterIm[Offset] = ((BYTE*) filterbitmap.bmBits)[y*filterbitmap.bmWidthBytes+x] / 255.0f;
										 Offset++;
									 }
								 }
							 }
							 if (LOWORD(wParam) == IDM_FILTER_IMPORTFROMBMPFILE)
							 {
							   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
								 {
									 pSP->FilterIm[Offset] = 0;
								 }
							 }
							 DeleteObject(hFilterBitmap);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_IMPORTFROMBMPCLIP:
					case IDM_FILTER_IMPORTREALFROMBMPCLIP:
					case IDM_FILTER_IMPORTIMAGFROMBMPCLIP:
							 hFilterBitmap = PasteDIBfromClipboard(hDlg, bTemp);
							 if (!hFilterBitmap)
							 {
								 MessageBox(hDlg, TEXT("Fehler beim ffnen der Bitmap-Datei! Falsches Format?"), TEXT("Particle Tracer - Filter importieren"), MB_OK | MB_ICONEXCLAMATION);
								 return TRUE;
							 }
							 GetObject(hFilterBitmap, sizeof(BITMAP), &filterbitmap);
							 if (filterbitmap.bmWidth!=pSP->Width  ||  filterbitmap.bmHeight!=pSP->Height)
							 {
								 DeleteObject(hFilterBitmap);
								 MessageBox(hDlg, TEXT("Bitmap hat nicht die korrekte Gre!"), TEXT("Particle Tracer - Filter importieren"), MB_OK | MB_ICONEXCLAMATION);
								 return TRUE;
							 }
							 if (LOWORD(wParam)==IDM_FILTER_IMPORTFROMBMPCLIP  ||  LOWORD(wParam)==IDM_FILTER_IMPORTREALFROMBMPCLIP)
							 {
								 Offset = 0;
								 for (y=0; y<pSP->Height; y++)
								 {
									 for (x=0; x<pSP->Width; x++)
									 {
										 pSP->FilterRe[Offset] = ((BYTE*) filterbitmap.bmBits)[y*filterbitmap.bmWidthBytes+x] / 255.0f;
										 Offset++;
									 }
								 }
							 }
							 if (LOWORD(wParam)==IDM_FILTER_IMPORTIMAGFROMBMPCLIP)
							 {
								 Offset = 0;
								 for (y=0; y<pSP->Height; y++)
								 {
									 for (x=0; x<pSP->Width; x++)
									 {
										 pSP->FilterIm[Offset] = ((BYTE*) filterbitmap.bmBits)[y*filterbitmap.bmWidthBytes+x] / 255.0f;
										 Offset++;
									 }
								 }
							 }
							 if (LOWORD(wParam) == IDM_FILTER_IMPORTFROMBMPCLIP)
							 {
							   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
								 {
									 pSP->FilterIm[Offset] = 0;
								 }
							 }
							 DeleteObject(hFilterBitmap);
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_COPYUNFILTERED:
						   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
							 {
								 pSP->FilterRe[Offset] = pSP->OldSpectRe[Offset];
								 pSP->FilterIm[Offset] = pSP->OldSpectIm[Offset];
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
						   return TRUE;

					case IDM_FILTER_IDENTITY:
							 for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
							 {
								 pSP->FilterRe[Offset] = 1;
								 pSP->FilterIm[Offset] = 0;
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_GAUSS:
						{
							 double SelCenterX = ((double) (SelRect.left   + SelRect.right)) / 2;
							 double SelCenterY = ((double) (SelRect.bottom + SelRect.top  )) / 2;
							 double a = ((double) (SelRect.right-SelRect.left   + 1)) / 2;
							 double b = ((double) (SelRect.top  -SelRect.bottom + 1)) / 2;
							 a *= a;  b *= b;

						   for (y=0; y<pSP->Height; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = float(exp(-(x-SelCenterX)*(x-SelCenterX)/a - (y-SelCenterY)*(y-SelCenterY)/b));
									 pSP->FilterIm[Offset] = 0.0f;
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;
						}

					case IDM_FILTER_INSEL_ELLIP:
						{
							 double SelCenterX = ((double) (SelRect.left   + SelRect.right)) / 2;
							 double SelCenterY = ((double) (SelRect.bottom + SelRect.top  )) / 2;
							 double a = ((double) (SelRect.right-SelRect.left   + 1)) / 2;
							 double b = ((double) (SelRect.top  -SelRect.bottom + 1)) / 2;
							 a *= a;  b *= b;

						   for (y=SelRect.bottom; y<=SelRect.top; y++)
							 {
								 Offset = y*pSP->Width + SelRect.left;
								 for (x=SelRect.left; x<=SelRect.right; x++)
								 {
									 if ( (x-SelCenterX)*(x-SelCenterX) / a  +  (y-SelCenterY)*(y-SelCenterY) / b <= 1.0)
									 {
										 pSP->FilterRe[Offset] = 1;
										 pSP->FilterIm[Offset] = 0;
									 }
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;
						}

					case IDM_FILTER_INSEL_RECT:
						   for (y=SelRect.bottom; y<=SelRect.top; y++)
							 {
								 Offset = y*pSP->Width+SelRect.left;
								 for (x=SelRect.left; x<=SelRect.right; x++)
								 {
									 pSP->FilterRe[Offset] = 1;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_OUTSEL_ELLIP:
						{
							 double SelCenterX = ((double) (SelRect.left   + SelRect.right)) / 2;
							 double SelCenterY = ((double) (SelRect.bottom + SelRect.top  )) / 2;
							 double a = ((double) (SelRect.right-SelRect.left   + 1)) / 2;
							 double b = ((double) (SelRect.top  -SelRect.bottom + 1)) / 2;
							 a *= a;  b *= b;

						   for (y=0; y<pSP->Height; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 if ( (x-SelCenterX)*(x-SelCenterX) / a  +  (y-SelCenterY)*(y-SelCenterY) / b >= 1.0)
									 {
										 pSP->FilterRe[Offset] = 1;
										 pSP->FilterIm[Offset] = 0;
									 }
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;
						}

					case IDM_FILTER_OUTSEL_RECT:
						   for (y=0; y<SelRect.bottom; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = 1;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
						   for (y=SelRect.bottom; y<=SelRect.top; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<SelRect.left; x++)
								 {
									 pSP->FilterRe[Offset] = 1;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
								 Offset = y*pSP->Width+SelRect.right+1;
								 for (x=SelRect.right+1; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = 1;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
						   for (y=SelRect.top+1; y<pSP->Height; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = 1;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_HP_ELLIP:
						{
							 double SelCenterX = ((double) (SelRect.left   + SelRect.right)) / 2;
							 double SelCenterY = ((double) (SelRect.bottom + SelRect.top  )) / 2;
							 double a = ((double) (SelRect.right-SelRect.left   + 1)) / 2;
							 double b = ((double) (SelRect.top  -SelRect.bottom + 1)) / 2;
							 a *= a;  b *= b;

						   for (y=SelRect.bottom; y<=SelRect.top; y++)
							 {
								 Offset = y*pSP->Width + SelRect.left;
								 for (x=SelRect.left; x<=SelRect.right; x++)
								 {
									 if ( (x-SelCenterX)*(x-SelCenterX) / a  +  (y-SelCenterY)*(y-SelCenterY) / b <= 1.0)
									 {
										 pSP->FilterRe[Offset] = 0;
										 pSP->FilterIm[Offset] = 0;
									 }
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;
						}

					case IDM_FILTER_HP_RECT:
						   for (y=SelRect.bottom; y<=SelRect.top; y++)
							 {
								 Offset = y*pSP->Width+SelRect.left;
								 for (x=SelRect.left; x<=SelRect.right; x++)
								 {
									 pSP->FilterRe[Offset] = 0;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_LP_ELLIP:
						{
							 double SelCenterX = ((double) (SelRect.left   + SelRect.right)) / 2;
							 double SelCenterY = ((double) (SelRect.bottom + SelRect.top  )) / 2;
							 double a = ((double) (SelRect.right-SelRect.left   + 1)) / 2;
							 double b = ((double) (SelRect.top  -SelRect.bottom + 1)) / 2;
							 a *= a;  b *= b;

						   for (y=0; y<pSP->Height; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 if ( (x-SelCenterX)*(x-SelCenterX) / a  +  (y-SelCenterY)*(y-SelCenterY) / b >= 1.0)
									 {
										 pSP->FilterRe[Offset] = 0;
										 pSP->FilterIm[Offset] = 0;
									 }
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;
						}

					case IDM_FILTER_LP_RECT:
						   for (y=0; y<SelRect.bottom; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = 0;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
						   for (y=SelRect.bottom; y<=SelRect.top; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<SelRect.left; x++)
								 {
									 pSP->FilterRe[Offset] = 0;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
								 Offset = y*pSP->Width+SelRect.right+1;
								 for (x=SelRect.right+1; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = 0;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
						   for (y=SelRect.top+1; y<pSP->Height; y++)
							 {
								 Offset = y*pSP->Width;
								 for (x=0; x<pSP->Width; x++)
								 {
									 pSP->FilterRe[Offset] = 0;
									 pSP->FilterIm[Offset] = 0;
									 Offset++;
								 }
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_FILTER_MULTIPLY:
							 strcpy(InpNr.szCaption, TEXT("Bitte geben Sie eine komplexe Zahl ein:"));
							 strcpy(InpNr.szLabelNr1, TEXT("Realteil:"));
							 strcpy(InpNr.szLabelNr2, TEXT("Imaginrteil:"));
							 InpNr.EditNr1 = 1.0;
							 InpNr.EditNr2 = 0.0;
							 InpNr.Nr1NonNegative = InpNr.Nr1Positiv = InpNr.Nr2NonNegative = InpNr.Nr2Positiv = FALSE;
							 if (!DialogBoxParam(hInstance, TEXT("InputNumberDlg"), hDlg, InputNumberDlgProc, (LPARAM) &InpNr))
								 return TRUE;
							 if (InpNr.EditNr1==1  &&  InpNr.EditNr2==0)  return TRUE;
						   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
							 {
								 f = pSP->FilterRe[Offset]*InpNr.EditNr1 - pSP->FilterIm[Offset]*InpNr.EditNr2;
								 pSP->FilterIm[Offset] = pSP->FilterRe[Offset]*InpNr.EditNr2 + pSP->FilterIm[Offset]*InpNr.EditNr1;
								 pSP->FilterRe[Offset] = f;
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
						   return TRUE;

					case IDM_FILTER_FLIP:
							 i = (pSP->Width) >> 1;
							 j = (pSP->Height) >> 1;
							 for (y=1; y<j; y++)
							 {
								 for (x=1; x<pSP->Width; x++)
								 {
									 f = pSP->FilterRe[y*pSP->Width+x];
									 pSP->FilterRe[y*pSP->Width+x] = pSP->FilterRe[(pSP->Height-y)*pSP->Width+(pSP->Width-x)];
									 pSP->FilterRe[(pSP->Height-y)*pSP->Width+(pSP->Width-x)] = f;
									 f = pSP->FilterIm[y*pSP->Width+x];
									 pSP->FilterIm[y*pSP->Width+x] = pSP->FilterIm[(pSP->Height-y)*pSP->Width+(pSP->Width-x)];
									 pSP->FilterIm[(pSP->Height-y)*pSP->Width+(pSP->Width-x)] = f;
								 }
							 }
							 Offset = j*pSP->Width;
							 for (x=1; x<i; x++)
							 {
								 f = pSP->FilterRe[Offset+x];
								 pSP->FilterRe[Offset+x] = pSP->FilterRe[Offset+(pSP->Width-x)];
								 pSP->FilterRe[Offset+(pSP->Width-x)] = f;
								 f = pSP->FilterIm[Offset+x];
								 pSP->FilterIm[Offset+x] = pSP->FilterIm[Offset+(pSP->Width-x)];
								 pSP->FilterIm[Offset+(pSP->Width-x)] = f;
							 }
							 for (x=1; x<i; x++)
							 {
								 f = pSP->FilterRe[x];
								 pSP->FilterRe[x] = pSP->FilterRe[pSP->Width-x];
								 pSP->FilterRe[pSP->Width-x] = f;
								 f = pSP->FilterIm[x];
								 pSP->FilterIm[x] = pSP->FilterIm[pSP->Width-x];
								 pSP->FilterIm[pSP->Width-x] = f;
							 }
							 for (y=1; y<j; y++)
							 {
								 f = pSP->FilterRe[y*pSP->Width];
								 pSP->FilterRe[y*pSP->Width] = pSP->FilterRe[(pSP->Height-y)*pSP->Width];
								 pSP->FilterRe[(pSP->Height-y)*pSP->Width] = f;
								 f = pSP->FilterIm[y*pSP->Width];
								 pSP->FilterIm[y*pSP->Width] = pSP->FilterIm[(pSP->Height-y)*pSP->Width];
								 pSP->FilterIm[(pSP->Height-y)*pSP->Width] = f;
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
						   return TRUE;

					case IDM_FILTER_CONJUGATE:
						   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
							 {
								 pSP->FilterIm[Offset] = -pSP->FilterIm[Offset];
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
						   return TRUE;

					case IDM_FILTER_REZIPROCE:
							 bTemp = TRUE;
						   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
							 {
								 pSP->Floats[Offset] = pSP->FilterRe[Offset]*pSP->FilterRe[Offset]  +  pSP->FilterIm[Offset]*pSP->FilterIm[Offset];
								 if (pSP->Floats[Offset]==0)
								 {
									 bTemp = FALSE;
									 break;
								 }
							 }
							 if (bTemp)
							 {
							   for (Offset=0; Offset<pSP->Width*pSP->Height; Offset++)
								 {
									 pSP->FilterRe[Offset] /=  pSP->Floats[Offset];
									 pSP->FilterIm[Offset] /= -pSP->Floats[Offset];
								 }
							 }
							 else
							 {
								 MessageBox(hDlg, TEXT("Reziproke Amplituden knnen nicht gebildet werden. Division durch Null!"), TEXT("Particle Tracer - Spektrum bearbeiten"), MB_OK | MB_ICONEXCLAMATION);
							 }
							 UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
							 return TRUE;

					case IDM_CANCEL:
						   EndDialog(hDlg, FALSE);
							 return TRUE;

					case IDM_EXIT:
						   MoveSpectrum(pSP->SpectRe, pSP->SpectIm, pSP->Floats, pSP->Width, pSP->Height, -1);
						   EndDialog(hDlg, TRUE);
							 return TRUE;
					}
          return 0;

		case WM_CLOSE:
			   SendMessage(hDlg, WM_COMMAND, IDM_CANCEL, 0);
				 return TRUE;

		case WM_KEYDOWN:
			   hMenu = GetMenu(hDlg);
			   if (wParam == VK_CONTROL  &&  GetMenuState(hMenu,IDM_TOOLS_MOVE, MF_BYCOMMAND) == MF_CHECKED)
				 {
					 bZoom = TRUE;
					 SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("zoomglass")) );
					 SetCursor(LoadCursor(hInstance, TEXT("zoomglass")));
				 }
				 return TRUE;
		
		case WM_KEYUP:
				 if (bScroll)  return TRUE;
			   hMenu = GetMenu(hDlg);
				 if (wParam == VK_ESCAPE  &&  GetMenuState(hMenu,IDM_TOOLS_SELECT, MF_BYCOMMAND) == MF_CHECKED  &&  (bSelecting  ||  bSelMoving))
				 {
					 ReleaseCapture();
					 bSelecting = FALSE;
					 bSelMoving = FALSE;
					 SelRect = OldSelRect;
					 InvalidateRect(hDlg, NULL, FALSE);
				 }
			   if (wParam == VK_CONTROL  &&  bZoom)
				 {
					 bZoom = FALSE;
					 if (hBitmap)
					 {
						 SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("crosscursor")) );
					   SetCursor(LoadCursor(hInstance, TEXT("crosscursor")));
					 }
					 else
					 {
						 SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(NULL, IDC_ARROW) );
					   SetCursor(LoadCursor(NULL, IDC_ARROW));
					 }
				 }
			   return TRUE;

		case WM_MOUSEWHEEL:
          iResult = 0;
			    if (hBitmap)
					{
				    if ((short) HIWORD(wParam)>0  &&  ShowSizeFactor<20)
						{
							ShowSizeFactor += 1.0f;
							iResult = +1;
						}
						if ((short) HIWORD(wParam)<0  &&  ShowSizeFactor>-10)
						{
							ShowSizeFactor -= 1.0f;
							iResult = -1;
						}
            if (iResult == 0)  break;

						Factor = ((double) (cxClient/2-xShow)) / ((double) ShowWidth);
						ShowWidth = ShowSizeFactor<0 ? long(-bitmap.bmWidth/(ShowSizeFactor-1)) : long(bitmap.bmWidth*(ShowSizeFactor+1));
						xShow = int(cxClient/2 - Factor*ShowWidth);
						Factor = ((double) (cyClient/2-yShow)) / ((double) ShowHeight);
						ShowHeight = ShowSizeFactor<0 ? long(-bitmap.bmHeight/(ShowSizeFactor-1)) : long(bitmap.bmHeight*(ShowSizeFactor+1));
						yShow = int(cyClient/2 - Factor*ShowHeight);
						
						CheckBorder(xShow, yShow, cxClient, cyClient, ShowWidth, ShowHeight);
						InvalidateRect(hDlg, NULL, FALSE);
					}
					return TRUE;

		 case WM_LBUTTONDBLCLK:
     case WM_LBUTTONDOWN:
					xMousePos = LOWORD(lParam);
					yMousePos = HIWORD(lParam);
					if (!hBitmap)  return TRUE;
			    hMenu = GetMenu(hDlg);
					if (GetMenuState(hMenu, IDM_TOOLS_SELECT, MF_BYCOMMAND) == MF_CHECKED)
					{
						Factor = (double) ShowWidth / bitmap.bmWidth;
						x = long((xMousePos-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						y = long((yShow+ShowHeight-1-yMousePos) / Factor);
						if (x<0)  x=0;
						if (x>=bitmap.bmWidth)  x=bitmap.bmWidth-1;
						if (y<0)  y=0;
						if (y>=bitmap.bmHeight) y=bitmap.bmHeight-1;
						OldSelRect = SelRect;
						XORSelRect.left = XORSelRect.bottom = 0;
						XORSelRect.right = bitmap.bmWidth-1;
						XORSelRect.top = bitmap.bmHeight-1;
						bTemp = SelRect.left==0  &&  SelRect.bottom==0  &&  SelRect.right==bitmap.bmWidth-1  &&  SelRect.top==bitmap.bmHeight-1;
						bTemp = bTemp || x<SelRect.left  ||  x>SelRect.right  ||  y<SelRect.bottom  ||  y>SelRect.top;
						if (bTemp)
						{
							SelRect.left = SelRect.right = x;
							SelRect.top = SelRect.bottom = y;
							bSelecting = TRUE;
							InvalidateRect(hDlg, NULL, FALSE);
						}
						else
						{
							bSelMoving = TRUE;
							wsprintf(szTemp, "Kx:  %li (%li)", (SelRect.left+SelRect.right)/2-(pSP->Width >>1), abs(SelRect.right-SelRect.left)+1);
							SetDlgItemText(pSP->hInfoBox, IDC_X_POS, szTemp);
							wsprintf(szTemp, "Ky:  %li (%li)", (SelRect.bottom+SelRect.top)/2-(pSP->Height>>1), abs(SelRect.top-SelRect.bottom)+1);
							SetDlgItemText(pSP->hInfoBox, IDC_Y_POS, szTemp);
							x = pBits[y*bitmap.bmWidthBytes + x];
							wsprintf(szTemp, "  (Markierung)");
							SetDlgItemText(pSP->hInfoBox, IDC_GRAYVALUE, szTemp);
						}
						SetCapture(hDlg);
					}
					if (GetMenuState(hMenu, IDM_TOOLS_DRAW, MF_BYCOMMAND) == MF_CHECKED  &&  !bDrawLB  &&  !bDrawRB)
					{
						Factor = (double) ShowWidth / bitmap.bmWidth;
						x = long((xMousePos-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						y = long((yShow+ShowHeight-1-yMousePos) / Factor);
						if (x>=0  &&  x<bitmap.bmWidth  &&  y>=0  &&  y<bitmap.bmHeight)
						{
							pMemBits = (BYTE*) malloc(pSP->Width*pSP->Height);
							bDrawingLine = FALSE;
							if (!bChanged)
							{
							  bChanged = TRUE;
							}
							XORSelRect.left = XORSelRect.right = x;
							XORSelRect.bottom = XORSelRect.top = y;
							DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 1.0, 0.0, 255, pMemBits);
							InvalidateRect(hDlg, NULL, FALSE);
							bDrawLB = TRUE;
							SetCapture(hDlg);
						}
					}

					if (GetMenuState(hMenu, IDM_TOOLS_MOVE, MF_BYCOMMAND) == MF_CHECKED)
					{
						if ((wParam & MK_CONTROL)  &&  ShowSizeFactor<20  &&  bZoom)
						{
					    ShowSizeFactor += 1.0f;
							Factor = ((double) (xMousePos-xShow)) / ((double) ShowWidth);
							ShowWidth = ShowSizeFactor<0 ? long(-bitmap.bmWidth/(ShowSizeFactor-1)) : long(bitmap.bmWidth*(ShowSizeFactor+1));
							xShow = int(cxClient/2 - Factor*ShowWidth);
							Factor = ((double) (yMousePos-yShow)) / ((double) ShowHeight);
							ShowHeight = ShowSizeFactor<0 ? long(-bitmap.bmHeight/(ShowSizeFactor-1)) : long(bitmap.bmHeight*(ShowSizeFactor+1));
							yShow = int(cyClient/2 - Factor*ShowHeight);
							CheckBorder(xShow, yShow, cxClient, cyClient, ShowWidth, ShowHeight);
							InvalidateRect(hDlg, NULL, FALSE);
						}
						if (!(wParam & MK_CONTROL))
						{
							SetCapture(hDlg);
							SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("closedhand")) );
							SetCursor(LoadCursor(hInstance, TEXT("closedhand")) );
							bScroll = TRUE;
						}
					}
			    return TRUE;

		 case WM_LBUTTONUP:
					xMousePos = LOWORD(lParam);
					yMousePos = HIWORD(lParam);
					if (!hBitmap)  return TRUE;
			    hMenu = GetMenu(hDlg);
					if (GetMenuState(hMenu,IDM_TOOLS_SELECT, MF_BYCOMMAND) == MF_CHECKED)
					{
						if (bSelecting)
						{
							bSelecting = FALSE;
						  ReleaseCapture();
							Factor = (double) ShowWidth / bitmap.bmWidth;
							x = long((xMousePos-xShow) / Factor);
							Factor = (double) ShowHeight / bitmap.bmHeight;
							y = long((yShow+ShowHeight-1-yMousePos) / Factor);
							if (x<0)  x=0;
							if (x>=bitmap.bmWidth)  x=bitmap.bmWidth-1;
							if (y<0)  y=0;
							if (y>=bitmap.bmHeight) y=bitmap.bmHeight-1;
							SelRect.right = x;
							SelRect.bottom = y;
							if (wParam & MK_CONTROL)
							{
								if (labs(SelRect.right-SelRect.left)>labs(SelRect.top-SelRect.bottom))
									SelRect.right = long(SelRect.left + _copysign(labs(SelRect.top-SelRect.bottom), SelRect.right-SelRect.left));
								else
									SelRect.bottom = long(SelRect.top + _copysign(labs(SelRect.right-SelRect.left), SelRect.bottom-SelRect.top));
							}
					    if (SelRect.right<SelRect.left)
							{
								x = SelRect.right;
								SelRect.right = SelRect.left;
								SelRect.left = x;
							}
					    if (SelRect.top<SelRect.bottom)
							{
								x = SelRect.bottom;
								SelRect.bottom = SelRect.top;
								SelRect.top = x;
							}
							bDelOldSelRect = TRUE;
							InvalidateRect(hDlg, NULL, FALSE);
						}
						if (bSelMoving)
						{
							bSelMoving = FALSE;
							ReleaseCapture();
							InvalidateRect(hDlg, NULL, FALSE);
						}
					}
					if (bDrawLB)
					{
						ReleaseCapture();
						bDrawLB = FALSE;
						Factor = (double) ShowWidth / bitmap.bmWidth;
						XORSelRect.right = long(((signed short) xMousePos-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						XORSelRect.top = long((yShow+ShowHeight-1-(signed short) yMousePos) / Factor);
						DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 1.0, 0.0, 255, pMemBits);
						if (pMemBits)  free(pMemBits);
						UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
					}
					if (GetMenuState(hMenu,IDM_TOOLS_MOVE, MF_BYCOMMAND) == MF_CHECKED  &&  bScroll)
					{
					  ReleaseCapture();
						bScroll = FALSE;
						SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("openhand")) );
						SetCursor(LoadCursor(hInstance, TEXT("openhand")) );
					}
					break;			    

		 case WM_RBUTTONDBLCLK:
		 case WM_RBUTTONDOWN:
					if (!hBitmap)  return TRUE;
	  	    hMenu = GetMenu(hDlg);
					if (GetMenuState(hMenu,IDM_TOOLS_SELECT, MF_BYCOMMAND) == MF_CHECKED  &&  !bSelecting)
					{
						if (!(wParam & MK_CONTROL))
						{
							SelRect.bottom = SelRect.left = 0;
							SelRect.top = bitmap.bmHeight-1;
							SelRect.right = bitmap.bmWidth-1;
							InvalidateRect(hDlg, NULL, FALSE);
						}
						else
						{
							Factor = (double) ShowWidth / bitmap.bmWidth;
							x = long((LOWORD(lParam)-xShow) / Factor);
							Factor = (double) ShowHeight / bitmap.bmHeight;
							y = long((yShow+ShowHeight-1-HIWORD(lParam)) / Factor);
							if (x<0)  x=0;
							if (x>=bitmap.bmWidth)  x=bitmap.bmWidth-1;
							if (y<0)  y=0;
							if (y>=bitmap.bmHeight) y=bitmap.bmHeight-1;
							SelRect.right = x;
							SelRect.bottom = y;
					    if (SelRect.right<SelRect.left)
							{
								x = SelRect.right;
								SelRect.right = SelRect.left;
								SelRect.left = x;
							}
					    if (SelRect.top<SelRect.bottom)
							{
								x = SelRect.bottom;
								SelRect.bottom = SelRect.top;
								SelRect.top = x;
							}
							InvalidateRect(hDlg, NULL, FALSE);
						}
					}
					if (GetMenuState(hMenu, IDM_TOOLS_DRAW, MF_BYCOMMAND) == MF_CHECKED  &&  !bDrawLB  &&  !bDrawRB)
					{
						Factor = (double) ShowWidth / bitmap.bmWidth;
						x = long((xMousePos-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						y = long((yShow+ShowHeight-1-yMousePos) / Factor);
						if (x>=0  &&  x<bitmap.bmWidth  &&  y>=0  &&  y<bitmap.bmHeight)
						{
							SaveForUndo(hBitmap, TEXT("Zeichnen"));
							pMemBits = (BYTE*) malloc(pSP->Width*pSP->Height);
							bDrawingLine = FALSE;
							if (!bChanged)
							{
							  bChanged = TRUE;
							}
							XORSelRect.left = XORSelRect.right = x;
							XORSelRect.bottom = XORSelRect.top = y;
							DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 0.0, 0.0, 0, pMemBits);
							InvalidateRect(hDlg, NULL, FALSE);
							bDrawRB = TRUE;
							SetCapture(hDlg);
						}
					}
					if (GetMenuState(hMenu,IDM_TOOLS_MOVE, MF_BYCOMMAND) == MF_CHECKED)
					{
						if ((wParam & MK_CONTROL)  &&  ShowSizeFactor>-10)
						{
							ShowSizeFactor -= 1.0f;
							Factor = ((double) (xMousePos-xShow)) / ((double) ShowWidth);
							ShowWidth = ShowSizeFactor<0 ? long(-bitmap.bmWidth/(ShowSizeFactor-1)) : long(bitmap.bmWidth*(ShowSizeFactor+1));
							xShow = int(cxClient/2 - Factor*ShowWidth);
							Factor = ((double) (yMousePos-yShow)) / ((double) ShowHeight);
							ShowHeight = ShowSizeFactor<0 ? long(-bitmap.bmHeight/(ShowSizeFactor-1)) : long(bitmap.bmHeight*(ShowSizeFactor+1));
							yShow = int(cyClient/2 - Factor*ShowHeight);
							CheckBorder(xShow, yShow, cxClient, cyClient, ShowWidth, ShowHeight);
							InvalidateRect(hDlg, NULL, FALSE);
						}
						if (!(wParam & MK_CONTROL))
						{
						  xShow=(cxClient-ShowWidth)/2;
						  yShow=(cyClient-ShowHeight)/2;
							InvalidateRect(hDlg,0,FALSE);
						}
					}
			    return TRUE;

		 case WM_RBUTTONUP:
					if (bDrawRB)
					{
						ReleaseCapture();
						bDrawRB = FALSE;
						// Original wiederherstellen?
						//DrawLine(hBitmap, XORSelRect, PenWidth, -1);
						Factor = (double) ShowWidth / bitmap.bmWidth;
						XORSelRect.right = long(((signed short) xMousePos-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						XORSelRect.top = long((yShow+ShowHeight-1-(signed short) yMousePos) / Factor);
						DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 0.0, 0.0, 0, pMemBits);
						if (pMemBits)  free(pMemBits);
						UpdateSpectBMP(hDlg, hBitmap, *pSP, Power, TRUE);
					}
			    return TRUE;

		 case WM_MOUSEMOVE:
					x = (signed short) LOWORD(lParam);
					y = (signed short) HIWORD(lParam);
					hMenu = GetMenu(hDlg);
					if (!(wParam & MK_CONTROL))  bZoom = FALSE;
					if (!hBitmap)
					{
						SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(NULL, IDC_ARROW) );
						SetDlgItemText (pSP->hInfoBox, IDC_X_POS, TEXT("X: (Kein Bild)"));
						SetDlgItemText (pSP->hInfoBox, IDC_Y_POS, TEXT("Y: (Kein Bild)"));
						SetDlgItemText (pSP->hInfoBox, IDC_GRAYVALUE, TEXT("Grauwert: ---"));
						xMousePos = x;
						yMousePos = y;
						return TRUE;
					}
					if (bDrawLB  ||  bDrawRB)
					{
						if (bDrawingLine)	DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 0.0, 0.0, -1, pMemBits);
						if (!bDrawingLine  &&  (wParam & MK_CONTROL))
						{
							if (pMemBits)
							{
								CopyMemory(pMemBits, pBits, bitmap.bmWidthBytes*bitmap.bmHeight);
								CopyMemory(pSP->SpectRe, pSP->FilterRe, pSP->Width*pSP->Height*sizeof(pSP->SpectRe[0]));
								CopyMemory(pSP->SpectIm, pSP->FilterIm, pSP->Width*pSP->Height*sizeof(pSP->SpectRe[0]));
								bDrawingLine = TRUE;
							}
						}
						if (bDrawingLine  &&  !(wParam & MK_CONTROL))
						{
							bDrawingLine = FALSE;
							if (bDrawLB)
								DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 1.0, 0.0, 255, pMemBits);
							else
								DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 0.0, 0.0, 0, pMemBits);
							XORSelRect.left = XORSelRect.right;
							XORSelRect.bottom = XORSelRect.top;
						}
						Factor = (double) ShowWidth / bitmap.bmWidth;
						XORSelRect.right = long((x-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						XORSelRect.top = long((yShow+ShowHeight-1-y) / Factor);
						if (bDrawLB)
							DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 1.0, 0.0, 255, pMemBits);
						else
							DrawLineInFFT(*pSP, SelRect, XORSelRect, PenWidth, 0.0, 0.0, 0, pMemBits);
						if (!bDrawingLine)
						{
							XORSelRect.left = XORSelRect.right;
							XORSelRect.bottom = XORSelRect.top;
						}
						InvalidateRect(hDlg, NULL, FALSE);
					}
					if (bSelMoving)
					{
						x = x - xMousePos;
						Factor = (double) ShowWidth / bitmap.bmWidth;
						x = long(x/Factor);
						if (OldSelRect.right+x>bitmap.bmWidth-1)  x=bitmap.bmWidth-1-OldSelRect.right;
						if (OldSelRect.left+x<0)   x = -OldSelRect.left;
						y = yMousePos - y;
						Factor = (double) ShowHeight / bitmap.bmHeight;
						y = long(y/Factor);
						if (OldSelRect.top+y>bitmap.bmHeight-1)  y=bitmap.bmHeight-1-OldSelRect.top;
						if (OldSelRect.bottom+y<0)   y = -OldSelRect.bottom;
						SelRect.left   = OldSelRect.left   + x;
						SelRect.right  = OldSelRect.right  + x;
						SelRect.bottom = OldSelRect.bottom + y;
						SelRect.top    = OldSelRect.top    + y;
						if (wParam & MK_CONTROL)
						{
							long SelHeight = SelRect.top   - SelRect.bottom + 1;
							long SelWidth  = SelRect.right - SelRect.left   + 1;
							SelRect.bottom = (pSP->Height - SelHeight - 1) / 2 + 1;
							SelRect.top    = SelRect.bottom + SelHeight - 1;
							SelRect.left   = (pSP->Width  - SelWidth - 1) / 2 + 1;
							SelRect.right  = SelRect.left + SelWidth - 1;
						}
						bDelOldSelRect = TRUE;
						InvalidateRect(hDlg, NULL, FALSE);
					}
					if (bSelecting)
					{
						Factor = (double) ShowWidth / bitmap.bmWidth;
						SelRect.right = long((x-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						SelRect.bottom = long((yShow+ShowHeight-1-y) / Factor);
						if (SelRect.right<0)  SelRect.right=0;
						if (SelRect.right>=bitmap.bmWidth)  SelRect.right=bitmap.bmWidth-1;
						if (SelRect.bottom<0)  SelRect.bottom=0;
						if (SelRect.bottom>=bitmap.bmHeight) SelRect.bottom=bitmap.bmHeight-1;
						if (wParam & MK_CONTROL)
						{
							if (labs(SelRect.right-SelRect.left)>labs(SelRect.top-SelRect.bottom))
								SelRect.right = SelRect.left + labs(SelRect.top-SelRect.bottom) * ((SelRect.right-SelRect.left)
								                                                                    /labs(SelRect.right-SelRect.left));
							else
								SelRect.bottom = SelRect.top + labs(SelRect.right-SelRect.left) * ((SelRect.bottom-SelRect.top)
								                                                                    /labs(SelRect.bottom-SelRect.top));
						}
						bDelOldSelRect = TRUE;
						InvalidateRect(hDlg, NULL, FALSE);
					}
					if (bScroll)
					{
						if (cxClient<ShowWidth)
						{
							if (xShow + x - xMousePos > 0)  xMousePos = xShow + x;
						  if (xShow + x - xMousePos < cxClient - ShowWidth)  xMousePos = xShow + x - cxClient + ShowWidth;
						}
						else
						{
							if (xShow + x - xMousePos < 0)  xMousePos = xShow + x;
							if (xShow + x - xMousePos > cxClient - ShowWidth)  xMousePos = xShow + x - cxClient + ShowWidth;
						}
						if (cyClient<ShowHeight)
						{
							if (yShow + y - yMousePos > 0)  yMousePos = yShow + y;
						  if (yShow + y - yMousePos < cyClient - ShowHeight)  yMousePos = yShow + y - cyClient + ShowHeight;
						}
						else
						{
							if (yShow + y - yMousePos < 0)  yMousePos = yShow + y;
							if (yShow + y - yMousePos > cyClient - ShowHeight)  yMousePos = yShow + y - cyClient + ShowHeight;
						}
						
						ScrollWindow (hDlg, x - xMousePos, y - yMousePos, NULL, NULL);
						xShow += x - xMousePos;
						yShow += y - yMousePos;
						UpdateWindow(hDlg);
					}
					else if (bZoom)
						SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("zoomglass")) );
					else
						SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(hInstance, TEXT("crosscursor")) );

					if (!bSelMoving)
					{
						xMousePos = x;
						yMousePos = y;
					}
			    //Pixelposition in InfoBox anzeigen...
					if (bSelecting)
					{
						wsprintf(szTemp, "Breite:  %li", abs(SelRect.right-SelRect.left)+1);
						SetDlgItemText(pSP->hInfoBox, IDC_X_POS, szTemp);
						wsprintf(szTemp, "Hhe:  %li", abs(SelRect.top-SelRect.bottom)+1);
						SetDlgItemText(pSP->hInfoBox, IDC_Y_POS, szTemp);
						wsprintf(szTemp, "  (der Markierung)");
						SetDlgItemText(pSP->hInfoBox, IDC_GRAYVALUE, szTemp);
					}
					else if (xMousePos<xShow || xMousePos>=xShow+ShowWidth || yMousePos<yShow || yMousePos>=yShow+ShowHeight)
					{
						SetDlgItemText (pSP->hInfoBox, IDC_X_POS, TEXT("Kx: (auerhalb)"));
						SetDlgItemText (pSP->hInfoBox, IDC_Y_POS, TEXT("Ky: (auerhalb)"));
						SetDlgItemText (pSP->hInfoBox, IDC_GRAYVALUE, TEXT("Grauwert: ---"));
					}
					else if (bSelMoving)
					{
						wsprintf(szTemp, "Kx:  %li (%li)", (SelRect.left+SelRect.right)/2-(pSP->Width >>1), abs(SelRect.right-SelRect.left)+1);
						SetDlgItemText(pSP->hInfoBox, IDC_X_POS, szTemp);
						wsprintf(szTemp, "Ky:  %li (%li)", (SelRect.bottom+SelRect.top)/2-(pSP->Height>>1), abs(SelRect.top-SelRect.bottom)+1);
						SetDlgItemText(pSP->hInfoBox, IDC_Y_POS, szTemp);
						wsprintf(szTemp, "  (Markierung)");
						SetDlgItemText(pSP->hInfoBox, IDC_GRAYVALUE, szTemp);
					}
					else
					{
						Factor = (double) ShowWidth / bitmap.bmWidth;
						x = long((xMousePos-xShow) / Factor);
						Factor = (double) ShowHeight / bitmap.bmHeight;
						y = long((yShow+ShowHeight-1-yMousePos) / Factor);
						wsprintf(szTemp, "Kx:  %li/%li", x-(pSP->Width>>1), bitmap.bmWidth>>1);
						SetDlgItemText(pSP->hInfoBox, IDC_X_POS, szTemp);
						wsprintf(szTemp, "Ky:  %li/%li", y-(pSP->Height>>1), bitmap.bmHeight>>1);
						SetDlgItemText(pSP->hInfoBox, IDC_Y_POS, szTemp);
						x = pBits[y*bitmap.bmWidthBytes + x];
						wsprintf(szTemp, "Grauwert:  %li", x);
						SetDlgItemText(pSP->hInfoBox, IDC_GRAYVALUE, szTemp);
					}
					break;

		 case WM_PAINT:
			    ValidateRect(hDlg, NULL);
			    InvalidateRect(hDlg, NULL, FALSE);
          hdc = BeginPaint (hDlg, &ps);
          if (hBitmap)
          {    // Bitmap im Anwendungsbereich zeichnen
					  if ((XORSelRect.left!=0  ||  XORSelRect.right!=bitmap.bmWidth-1  ||  XORSelRect.bottom!=0  ||  XORSelRect.top!=bitmap.bmHeight-1)  &&  bDelOldSelRect)
						{
							DrawSelectionRect(hdc, bitmap, xShow, yShow, ShowWidth, ShowHeight, XORSelRect, TRUE);
						}
						if (!bSelecting && !bSelMoving)
						{
							if (xShow>0)
							{
								rect.top = rect.left = 0;
								rect.right = xShow;
								rect.bottom = cyClient;
								FillRect(hdc, &rect, (HBRUSH) GetClassLong(GetParent(hDlg), GCL_HBRBACKGROUND));
							}
							if (xShow+ShowWidth<cxClient)
							{
								rect.top = 0;
								rect.left = xShow+ShowWidth;
								rect.right = cxClient;
								rect.bottom = cyClient;
								FillRect(hdc, &rect, (HBRUSH) GetClassLong(GetParent(hDlg), GCL_HBRBACKGROUND));
							}
							if (yShow>0)
							{
								rect.top = rect.left = 0;
								rect.right = cxClient;
								rect.bottom = yShow;
								FillRect(hdc, &rect, (HBRUSH) GetClassLong(GetParent(hDlg), GCL_HBRBACKGROUND));
							}
							if (yShow+ShowHeight<cyClient)
							{
								rect.top = yShow+ShowHeight;
								rect.left = 0;
								rect.right = cxClient;
								rect.bottom = cyClient;
								FillRect(hdc, &rect, (HBRUSH) GetClassLong(GetParent(hDlg), GCL_HBRBACKGROUND));
							}
							PaintTheBitmap(hdc, hBitmap, xShow, yShow, ShowWidth, ShowHeight, cxClient, cyClient);
						}
					  if (SelRect.left!=0  ||  SelRect.right!=bitmap.bmWidth-1  ||  SelRect.bottom!=0  ||  SelRect.top!=bitmap.bmHeight-1  ||  bDelOldSelRect)
						{
							bTemp = bSelecting || bSelMoving;
							DrawSelectionRect(hdc, bitmap, xShow, yShow, ShowWidth, ShowHeight, SelRect, bTemp);
							if (bSelecting  ||  bSelMoving)  XORSelRect = SelRect;
							bDelOldSelRect = FALSE;
						}
					}
          EndPaint (hDlg, &ps) ;
          return TRUE;
     
     case WM_DESTROY:
          return TRUE ;
     }
		 if (MSWHEEL_ROLLMSG!=0  &&  message == MSWHEEL_ROLLMSG)
			 SendMessage(hDlg, WM_MOUSEWHEEL, LOWORD(wParam)<<16, lParam);
		 return FALSE;
}


void MoveSpectrum(float *fRe, float *fIm, float *pFloats, long Width, long Height, int Sign)
{
	long y, OffsetS, OffsetD, lw, rw, th, bh;
	unsigned long Size;

	Size = Width*Height*sizeof(float);
	if (Sign>0)
	{
		rw = Width>>1;
		lw = Width-rw;
		th = Height>>1;
		bh = Height-th;
	}
	else
	{
		lw = Width>>1;
		rw = Width-lw;
		bh = Height>>1;
		th = Height-bh;
	}

	CopyMemory(pFloats, fRe, Size);
	OffsetS = 0;
	OffsetD = th*Width;
	for (y=0; y<bh; y++)
	{
		CopyMemory(fRe+OffsetD, pFloats+OffsetS+lw, rw*sizeof(float));
		CopyMemory(fRe+OffsetD+rw, pFloats+OffsetS, lw*sizeof(float));
		OffsetS += Width;
		OffsetD += Width;
	}
	OffsetS = bh*Width;
	OffsetD = 0;
	for (y=0; y<bh; y++)
	{
		CopyMemory(fRe+OffsetD, pFloats+OffsetS+lw, rw*sizeof(float));
		CopyMemory(fRe+OffsetD+rw, pFloats+OffsetS, lw*sizeof(float));
		OffsetS += Width;
		OffsetD += Width;
	}

	CopyMemory(pFloats, fIm, Size);
	OffsetS = 0;
	OffsetD = th*Width;
	for (y=0; y<bh; y++)
	{
		CopyMemory(fIm+OffsetD, pFloats+OffsetS+lw, rw*sizeof(float));
		CopyMemory(fIm+OffsetD+rw, pFloats+OffsetS, lw*sizeof(float));
		OffsetS += Width;
		OffsetD += Width;
	}
	OffsetS = bh*Width;
	OffsetD = 0;
	for (y=0; y<bh; y++)
	{
		CopyMemory(fIm+OffsetD, pFloats+OffsetS+lw, rw*sizeof(float));
		CopyMemory(fIm+OffsetD+rw, pFloats+OffsetS, lw*sizeof(float));
		OffsetS += Width;
		OffsetD += Width;
	}
}


void UpdateSpectBMP(HWND hDlg, HBITMAP hBitmap, SPECTRUMPARAM sp, float Power, BOOL UpdateFilteredSpect)
{
	HMENU  hMenu;
	BITMAP bitmap;
	BYTE   *pBits;
	float  fMax, fMin, f, *fRe, *fIm;
	unsigned long   x, y, Offset, Size;

	if (!hBitmap) return;
	SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(NULL, IDC_WAIT) );
  SetCursor (LoadCursor (NULL, IDC_WAIT)) ;
	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	pBits = (BYTE*) bitmap.bmBits;
	hMenu = GetMenu(hDlg);
	Size = sp.Width*sp.Height;
	if (UpdateFilteredSpect)
	{
		for (Offset=0; Offset<Size; Offset++)
		{
			sp.SpectRe[Offset] = sp.OldSpectRe[Offset]*sp.FilterRe[Offset] - sp.OldSpectIm[Offset]*sp.FilterIm[Offset];
			sp.SpectIm[Offset] = sp.OldSpectRe[Offset]*sp.FilterIm[Offset] + sp.OldSpectIm[Offset]*sp.FilterRe[Offset];
		}
	}
	if (GetMenuState(hMenu,IDM_VIEW_UNFILTERED, MF_BYCOMMAND) == MF_CHECKED)
	{
		fRe = sp.OldSpectRe;
		fIm = sp.OldSpectIm;
	}
	
	if (GetMenuState(hMenu,IDM_VIEW_FILTER, MF_BYCOMMAND) == MF_CHECKED)
	{
		fRe = sp.FilterRe;
		fIm = sp.FilterIm;
	}

	if (GetMenuState(hMenu,IDM_VIEW_FILTERED, MF_BYCOMMAND) == MF_CHECKED)
	{
		fRe = sp.SpectRe;
		fIm = sp.SpectIm;
	}
	
  if (GetMenuState(hMenu,IDM_VIEW_ABS, MF_BYCOMMAND) == MF_CHECKED)
	{
		for (Offset=0; Offset<Size; Offset++)
		{
			sp.Floats[Offset] = fRe[Offset]*fRe[Offset] + fIm[Offset]*fIm[Offset];
		}
	}
  if (GetMenuState(hMenu,IDM_VIEW_PHASE, MF_BYCOMMAND) == MF_CHECKED)
	{
		for (Offset=0; Offset<Size; Offset++)
		{
			sp.Floats[Offset] = atan2(fIm[Offset], fRe[Offset])+(float) Pi;
		}
	}
	
  if (GetMenuState(hMenu,IDM_VIEW_REAL, MF_BYCOMMAND) == MF_CHECKED)
	{
		for (Offset=0; Offset<Size; Offset++)
		{
			sp.Floats[Offset] = fabs(fRe[Offset]);
		}
	}

  if (GetMenuState(hMenu,IDM_VIEW_IMAG, MF_BYCOMMAND) == MF_CHECKED)
	{
		for (Offset=0; Offset<Size; Offset++)
		{
			sp.Floats[Offset] = fabs(fIm[Offset]);
		}
	}
	
	if (GetMenuState(hMenu,IDM_VIEW_POWER, MF_BYCOMMAND) == MF_CHECKED)
	{
		fMin = 0;
		fMax = sp.Floats[0] = pow(sp.Floats[0], Power);
		for (Offset=1; Offset<Size; Offset++)
		{
			sp.Floats[Offset] = pow(sp.Floats[Offset], Power);
			if (sp.Floats[Offset]>fMax)  fMax=sp.Floats[Offset];
		}
		if (fMax>0)
			f = 255.0f/fMax;
		else
			f = 255.0f;
	}
	else
	{
		Offset = 0;
		f = 0;
		while (!sp.Floats[Offset])
		{
			Offset++;
			if (Offset>=Size)  break;
		}
		f = (Offset<Size) ? sp.Floats[Offset] : 0;
		Offset++;
		while (Offset<Size)
		{
			if (sp.Floats[Offset]<f)
				if (sp.Floats[Offset]>0) f=sp.Floats[Offset];
			Offset++;
		}
		f = log(f/10);
		fMin = fMax = sp.Floats[0] = (sp.Floats[0]>0) ? log(sp.Floats[0]) : f;
		for (Offset=1; Offset<Size; Offset++)
		{
			sp.Floats[Offset] = (sp.Floats[Offset]>0) ? log(sp.Floats[Offset]) : f;
			if (sp.Floats[Offset]>fMax)  fMax=sp.Floats[Offset];
			if (sp.Floats[Offset]<fMin)  fMin=sp.Floats[Offset];
		}
		if (fMax-fMin>0)
			f = 255.0f/(fMax-fMin);
		else
			f = 255.0f;
	}

	Offset = 0;
	for (y=0; long(y)<bitmap.bmHeight; y++)
	{
		Size = y*bitmap.bmWidthBytes;
		for (x=0; long(x)<bitmap.bmWidth; x++)
		{
      pBits[Size] = BYTE((sp.Floats[Offset]-fMin)*f);
			Offset++;
			Size++;
		}
	}
	SetClassLong(hDlg, GCL_HCURSOR, (long) LoadCursor(NULL, IDC_ARROW) );
  SetCursor (LoadCursor (NULL, IDC_ARROW)) ;
	InvalidateRect(hDlg, NULL, FALSE);
}




int LoadFFT(TCHAR *szFileName, float *fRe, float *fIm, long Width, long Height)
{
	HANDLE hFile;
	long   FileWidth, FileHeight;
	DWORD  dwSize, dwBytesRead;
  BOOL   bSuccess;
	char   szFileID[] = "Particle Tracer - FFT\0";
	char   szTmp[]    = "Particle Tracer - FFT\0";

	dwSize = Width*Height*sizeof(float);
  // Datei fr Lesezugriffe ffnen (und gegen Schreibaktionen anderer Prozesse sperren)
  hFile = CreateFile (szFileName, GENERIC_READ, FILE_SHARE_READ,
                      NULL, OPEN_EXISTING, 0, NULL) ;
  if (hFile == INVALID_HANDLE_VALUE)
       return 1;

  bSuccess = ReadFile (hFile, szTmp, strlen(szFileID), &dwBytesRead, NULL) ;
	if (!bSuccess || (dwBytesRead != strlen(szFileID)))
	{
		CloseHandle(hFile);
		return 1;
	}
	if (strcmp(szTmp, szFileID) != 0)
	{
		CloseHandle(hFile);
		return 2;
	}
  bSuccess = ReadFile (hFile, &FileWidth, sizeof(long), &dwBytesRead, NULL) ;
	if (!bSuccess || (dwBytesRead != sizeof(long)))
	{
		CloseHandle(hFile);
		return 1;
	}
  bSuccess = ReadFile (hFile, &FileHeight, sizeof(long), &dwBytesRead, NULL) ;
	if (!bSuccess || (dwBytesRead != sizeof(long)))
	{
		CloseHandle(hFile);
		return 1;
	}
	if (FileWidth!=Width  ||  FileHeight!=Height)
	{
		CloseHandle(hFile);
		return 3;
	}
  bSuccess = ReadFile (hFile, fRe, dwSize, &dwBytesRead, NULL) ;
	if (!bSuccess || (dwBytesRead != dwSize))
	{
		CloseHandle(hFile);
		return 4;
	}
  bSuccess = ReadFile (hFile, fIm, dwSize, &dwBytesRead, NULL) ;
	if (!bSuccess || (dwBytesRead != dwSize))
	{
		CloseHandle(hFile);
		return 4;
	}

	CloseHandle(hFile);
	return 0;
}



BOOL SaveFFT(TCHAR *szFileName, float *fRe, float *fIm, long Width, long Height)
{
	HANDLE hFile;
	DWORD  dwSize, dwBytesWritten;
  BOOL   bSuccess;
	char   szFileID[] = "Particle Tracer - FFT\0";

	dwSize = Width*Height*sizeof(float);
	hFile = CreateFile(szFileName, GENERIC_WRITE, 0, NULL,
		                 CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)  return FALSE;

	bSuccess = WriteFile(hFile, szFileID, strlen(szFileID), &dwBytesWritten, NULL);
	if (!bSuccess || (dwBytesWritten != strlen(szFileID)))
	{
		CloseHandle(hFile);
		DeleteFile(szFileName);
		return FALSE;
	}
	bSuccess = WriteFile(hFile, &Width, sizeof(long), &dwBytesWritten, NULL);
	if (!bSuccess || (dwBytesWritten != sizeof(long)))
	{
		CloseHandle(hFile);
		DeleteFile(szFileName);
		return FALSE;
	}
	bSuccess = WriteFile(hFile, &Height, sizeof(long), &dwBytesWritten, NULL);
	if (!bSuccess || (dwBytesWritten != sizeof(long)))
	{
		CloseHandle(hFile);
		DeleteFile(szFileName);
		return FALSE;
	}
	bSuccess = WriteFile(hFile, fRe, dwSize, &dwBytesWritten, NULL);
	if (!bSuccess || (dwBytesWritten != dwSize))
	{
		CloseHandle(hFile);
		DeleteFile(szFileName);
		return FALSE;
	}
	bSuccess = WriteFile(hFile, fIm, dwSize, &dwBytesWritten, NULL);
	if (!bSuccess || (dwBytesWritten != dwSize))
	{
		CloseHandle(hFile);
		DeleteFile(szFileName);
		return FALSE;
	}

	CloseHandle(hFile);
	return TRUE;
}



void DrawLineInFFT(SPECTRUMPARAM SP, RECT SelRect, RECT DrawRect, int PenWidth, float DrawRe, float DrawIm, int GrayVal, BYTE *pMemBits)
{
	HBITMAP hBitmap = SP.hSpectBMP;
	BITMAP  bitmap;
	BYTE    *pBits;
	long    x, y, i, j;
	double  f;

	if (!hBitmap)  return;
	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	pBits = (BYTE*) bitmap.bmBits;
	if (DrawRect.right-DrawRect.left==0  &&  DrawRect.top-DrawRect.bottom==0)
	{
		for (j=DrawRect.top-PenWidth/2; j<=DrawRect.top+(PenWidth-1)/2; j++)
		{
			if (j>=SelRect.bottom  &&  j<=SelRect.top)
			{
				for (i=DrawRect.left-(PenWidth-1)/2; i<=DrawRect.left+PenWidth/2; i++)
				{
					if (i>=SelRect.left  &&  i<=SelRect.right)
						if (GrayVal<0)
						{
							pBits[j*bitmap.bmWidthBytes+i] = pMemBits[j*bitmap.bmWidthBytes+i];
							SP.FilterRe[j*SP.Width+i] = SP.SpectRe[j*SP.Width+i];
							SP.FilterIm[j*SP.Width+i] = SP.SpectIm[j*SP.Width+i];
						} 
						else
						{
							pBits[j*bitmap.bmWidthBytes+i] = GrayVal;
							SP.FilterRe[j*SP.Width+i] = DrawRe;
							SP.FilterIm[j*SP.Width+i] = DrawIm;
						}
				}
			}
		}
		return;
	}
	if (abs(DrawRect.right-DrawRect.left)>abs(DrawRect.top-DrawRect.bottom))
	{
		if (DrawRect.left>DrawRect.right)
		{
			x = DrawRect.left;
			DrawRect.left = DrawRect.right;
			DrawRect.right = x;
			y = DrawRect.bottom;
			DrawRect.bottom = DrawRect.top;
			DrawRect.top = y;
		}
		f = (double) (DrawRect.top-DrawRect.bottom) / (DrawRect.right-DrawRect.left);
		for (x=DrawRect.left; x<=DrawRect.right; x++)
		{
			y = long(DrawRect.bottom + f*(x-DrawRect.left) + 0.5);
			for (j=y-PenWidth/2; j<=y+(PenWidth-1)/2; j++)
			{
				if (j>=SelRect.bottom  &&  j<=SelRect.top)
				{
					for (i=x-(PenWidth-1)/2; i<=x+PenWidth/2; i++)
					{
						if (i>=SelRect.left  &&  i<=SelRect.right)
							if (GrayVal<0)
							{
								pBits[j*bitmap.bmWidthBytes+i] = pMemBits[j*bitmap.bmWidthBytes+i];
								SP.FilterRe[j*SP.Width+i] = SP.SpectRe[j*SP.Width+i];
								SP.FilterIm[j*SP.Width+i] = SP.SpectIm[j*SP.Width+i];
							} 
							else
							{
								pBits[j*bitmap.bmWidthBytes+i] = GrayVal;
								SP.FilterRe[j*SP.Width+i] = DrawRe;
								SP.FilterIm[j*SP.Width+i] = DrawIm;
							}
					}
				}
			}
		}
	}
	else
	{
		if (DrawRect.bottom>DrawRect.top)
		{
			x = DrawRect.left;
			DrawRect.left = DrawRect.right;
			DrawRect.right = x;
			y = DrawRect.bottom;
			DrawRect.bottom = DrawRect.top;
			DrawRect.top = y;
		}
		f = (double) (DrawRect.right-DrawRect.left) / (DrawRect.top-DrawRect.bottom);
		for (y=DrawRect.bottom; y<=DrawRect.top; y++)
		{
			x = long(DrawRect.left + f*(y-DrawRect.bottom) + 0.5);
			for (j=y-PenWidth/2; j<=y+(PenWidth-1)/2; j++)
			{
				if (j>=SelRect.bottom  &&  j<=SelRect.top)
				{
					for (i=x-(PenWidth-1)/2; i<=x+PenWidth/2; i++)
					{
						if (i>=SelRect.left  &&  i<=SelRect.right)
							if (GrayVal<0)
							{
								pBits[j*bitmap.bmWidthBytes+i] = pMemBits[j*bitmap.bmWidthBytes+i];
								SP.FilterRe[j*SP.Width+i] = SP.SpectRe[j*SP.Width+i];
								SP.FilterIm[j*SP.Width+i] = SP.SpectIm[j*SP.Width+i];
							} 
							else
							{
								pBits[j*bitmap.bmWidthBytes+i] = GrayVal;
								SP.FilterRe[j*SP.Width+i] = DrawRe;
								SP.FilterIm[j*SP.Width+i] = DrawIm;
							}
					}
				}
			}
		}
	}
}
