#include <windows.h>
#include <math.h>
#include "resource.h"

#define Pi 3.141592653589793

typedef struct tagLINFILTER
{
  TCHAR szFilterFile[MAX_PATH];
	TCHAR szFilterName[80];
	float *FilterMatrix;
	int   FilterWidth;
	int   FilterHeight;
	int   BorderParam;
	float DivBy;
	float AddOffset;
	int   SignParam;
	int   NormalizeParam;
}
LINFILTER, *PLINFILTER;

typedef struct tagPARTICLEDATA
{
	double  X;
	double  Y;
	RECT    BoundRect;
	BYTE    GrayMax;
	double  GrayAvg;
	long  Area;
}
PARTICLEDATA, *PPARTICLEDATA;

typedef struct tagPARTICLEDATAINFO
{
	TCHAR        szFileName[MAX_PATH];
	int          ExportGermanNumberFormat;
	long         Algorithm;
	BYTE         GrayCutoff;
	long         MinArea, MaxArea;
	HBITMAP      hBitmap;
	PARTICLEDATA *Particles;
	long         NumParticles;
}
PARTICLEDATAINFO, *PPARTICLEDATAINFO;


BOOL CalcBitOp(HBITMAP hBitmap, WORD Operation, BYTE Operand);
BOOL CalcNormalize(HBITMAP hBitmap);
BOOL CalcLocalNormalize(HBITMAP hBitmap, int Width, int Height, int MaxMinTresh, int Compare);
BOOL CalcLocalRankOrder(HBITMAP hBitmap, int Width, int Height, int Rank);
BOOL LoadLinFilter(HWND hwnd, LINFILTER *LinFilter);
BOOL CalcLinFilter(HBITMAP hBitmap, LINFILTER  LinFilter);
BOOL CalcGradientFilter(HBITMAP hBitamp);
void FFT2D(float DataRe[], float DataIm[], unsigned long Width, unsigned long Height, int iSign);
long AreaBinarisation(HBITMAP hBitmap, BYTE GrayCutoff, long *Areas);
long SearchMaxima(HBITMAP hBitmap, BYTE GrayCutoff, long *Areas);
long AreaSeparation(HBITMAP hBitmap, long *Areas);
long AreaErosion(HBITMAP hBitmap, long *Areas, PARTICLEDATA *Particles, long NumParticles);
long AreaCenter(HBITMAP hBitmap, long *Areas, PARTICLEDATA *Particles, long NumParticles);
long CheckAreaSize(PARTICLEDATA *Particles, long &NumParticles, long MinArea, long MaxArea);
long ShowParticleCoord(HBITMAP hBitmap, PARTICLEDATA *Particles, long NumParticles);
long ExportParticleData(PARTICLEDATAINFO ParticleDataInfo);
